<?php
defined('ABSPATH') or die("No direct script access!");

/**
 * Add our field to the comment form
 */
add_action( 'comment_form_logged_in_after', 'qcld_clr_pro_comment_voice_msg_fields' );
add_action( 'comment_form_after_fields', 'qcld_clr_pro_comment_voice_msg_fields' );
function qcld_clr_pro_comment_voice_msg_fields(){

	$clr_optionss = get_option( 'comment_link_remove_option_name' );
    $enable_for_woocommerce = isset($clr_optionss['comment_show_voice_message_enable_for_woocommerce']) ? $clr_optionss['comment_show_voice_message_enable_for_woocommerce'] : '';

	if ( class_exists('WooCommerce') &&  is_product() && ($enable_for_woocommerce != '1') ) {
        return;
    }

	echo do_shortcode('[clrwpvoicemessage_clr]');

}


/**
 * Add the title to our admin area, for editing, etc
 */
add_action( 'add_meta_boxes_comment', 'qcld_clr_pro_comment_voice_msg_add_meta_box' );
function qcld_clr_pro_comment_voice_msg_add_meta_box(){

	add_meta_box( 'qcld_clr-comment-voice-msg', esc_html( 'Voice Message:',  'qc-clr' ), 'qcld_clr_pro_comment_voice_msg_meta_box_cb', 'comment', 'normal', 'high' );
}

function qcld_clr_pro_comment_voice_msg_meta_box_cb( $comment )
{
	$title 		= get_comment_meta( $comment->comment_ID, 'clrwpvoicemessage_clr', true );
	$audio_url 	= get_comment_meta( $comment->comment_ID, 'clrwpvoicemessage_clr', true );
	wp_nonce_field( 'qcld_clr_pro_comment_update', 'qcld_clr_pro_comment_update', false );

	if(!empty($title)){
	?>
	<p>
        <?php echo do_shortcode( '[audio src="' . $audio_url . '"]' ); ?>
        <div class="vmwpmdp-wpvoicemessage_clr-audio-info">
            <span class="dashicons dashicons-download" title="<?php esc_html_e( 'Download audio', 'wpvoicemessage_clr' ); ?>"></span>
            <a href="<?php echo esc_url( $audio_url ); ?>" download=""><?php esc_html_e( 'Download audio', 'wpvoicemessage_clr' ); ?></a>
        </div>
	</p>
	<?php
	}else{ ?>
		<p><?php esc_html_e( 'File not Found',  'qc-clr' ); ?> </p>
	<?php 
	}

}


/**
 * Save our title (from the front end)
 */
add_action( 'comment_post', 'qcld_clr_pro_comment_voice_msg_insert_comment', 10, 1 );
function qcld_clr_pro_comment_voice_msg_insert_comment( $comment_id )
{
	if( isset( $_POST['clrwpvoicemessage_clr'] ) )
		update_comment_meta( $comment_id, 'clrwpvoicemessage_clr', esc_attr( $_POST['clrwpvoicemessage_clr'] ) );
}


/**
 * add our headline to the comment text
 * Hook in way late to avoid colliding with default
 * WordPress comment text filters
 */
add_filter( 'comment_text', 'qcld_clr_pro_comment_voice_msg_add_title_to_text', 99, 2 );
function qcld_clr_pro_comment_voice_msg_add_title_to_text( $text, $comment )
{

	$clr_optionss = get_option( 'comment_link_remove_option_name' );
    $enable_for_woocommerce = isset($clr_optionss['comment_show_voice_message_enable_for_woocommerce']) ? $clr_optionss['comment_show_voice_message_enable_for_woocommerce'] : '';

	if ( class_exists('WooCommerce') && is_product() && ($enable_for_woocommerce != '1') ) {
        return $text;
    }

	if( is_admin() ) {
		$audio_url = get_comment_meta( $comment->comment_ID, 'clrwpvoicemessage_clr', true );

		if(!empty($audio_url)){
			$title = do_shortcode( '[audio src="' . $audio_url . '"]' );
			$text  = $text .$title;
		}

		return $text;
	}

	$title = get_comment_meta( $comment->comment_ID, 'clrwpvoicemessage_clr', true );
	if( !empty($title) ){
		
		$title = "<p>". do_shortcode( '[audio src="' . $title . '"]' ). "</p>";
		$text = $text . $title;
	}
	return $text;
}