<?php

defined('ABSPATH') or die("No direct script access!");

if ( ! function_exists( 'qcclr_comment_autoreply_admin_settings' ) ) {
    function qcclr_comment_autoreply_admin_settings(){

        ob_start();

        $qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );

        // Get status.
        $qcclr_enable_comment_autoreply = ! empty( $qcclr_autoreply_settings['qcclr_enable_comment_autoreply'] ) ? $qcclr_autoreply_settings['qcclr_enable_comment_autoreply'] : false;
        $qcclr_enable_comment_autoreply_child = ! empty( $qcclr_autoreply_settings['qcclr_enable_comment_autoreply_child'] ) ? $qcclr_autoreply_settings['qcclr_enable_comment_autoreply_child'] : false;
        $qcld_seohelp_ai_engines = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_engines'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_engines'] : false;

        $qcld_seohelp_api_key = ! empty( $qcclr_autoreply_settings['qcld_seohelp_api_key'] ) ? $qcclr_autoreply_settings['qcld_seohelp_api_key'] : '';
        // Get subject.
        $qcld_seohelp_max_token = ! empty( $qcclr_autoreply_settings['qcld_seohelp_max_token'] ) ? $qcclr_autoreply_settings['qcld_seohelp_max_token'] : '';
        // Get content.
        $qcld_seohelp_ai_temperature = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_temperature'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_temperature'] : '';
        // Get Selected.
        $qcld_seohelp_ai_ppenalty = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_ppenalty'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_ppenalty'] : '';
        $qcld_seohelp_ai_fpenalty = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_fpenalty'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_fpenalty'] : '';
        $qcld_seohelp_ai_include_comments = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] : '';
        $qcld_seohelp_ai_exclude_comments = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] : '';
        $qcld_seohelp_ai_reply_question_relevant_keywords = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] : '';

        $qcld_seohelp_ai_default_comment_prompt = "Please generate a relevant and thoughtful response to [username]'s comment on the post titled '[post_title]' with the excerpt '[post_excerpt]'. The user's latest comment is: '[last_comment]'. If applicable, consider the context of the previous conversation: '[parent_comments]'. Keep the response focused on the topic and avoid creating any new information.";

        $qcld_seohelp_ai_default_comment_prompt = ! empty( $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] : $qcld_seohelp_ai_default_comment_prompt;
        ?>
        <style>
            .form-table td p.description {
                display: inline;
            }
        </style>
            <div class="wrap  qcld_autoreply">
            <h1><?php esc_html_e( 'Comment Auto Reply Settings', 'qc-clr' ); ?></h1>

            <form method="post" action="">
                <?php wp_nonce_field( 'qcclr_autoreply_data_action', 'qcclr_autoreply_save_data_field' ); ?>
                <table class="form-table">
                    <tr valign="top">
                    <th scope="row"><?php esc_html_e( 'Enabled Comment Auto Reply', 'qc-clr' ); ?></th>
                    <td>
                        <input type="checkbox" name="qcclr_enable_comment_autoreply" value="1" <?php checked( $qcclr_enable_comment_autoreply, '1' ); ?> />
                        <p class="description"><?php esc_html_e( 'Auto Reply to approved comment', 'qc-clr' ); ?></p><br/>
                    </td>
                    </tr>
                    <tr valign="top">
                    <th scope="row"><?php esc_html_e( 'Child Comment Auto Reply', 'qc-clr' ); ?></th>
                    <td>
                        <input type="checkbox" name="qcclr_enable_comment_autoreply_child" value="1" <?php checked( $qcclr_enable_comment_autoreply_child, '1' ); ?> />
                        <p class="description"><?php esc_html_e( 'Auto Reply to child comments also', 'qc-clr' ); ?></p><br/>
                    </td>
                    </tr>

                    <tr valign="top">
                    <th scope="row"><?php esc_html_e('API KEY', 'seo-help'); ?></th>
                    <td>

                        <input type="text" class="form-control" name="qcld_seohelp_api_key" placeholder="<?php esc_html_e('API KEY', 'seo-help'); ?>" value="<?php echo $qcld_seohelp_api_key; ?>">
                        <p><a class="qcld_help_link" href="<?php echo esc_url('https://beta.openai.com/account/api-keys'); ?>" target="_blank"><?php esc_html_e('Get Your Api Key'); ?></a></p>
                    </td>
                    </tr>

                    <tr valign="top">
                    <th scope="row"><?php esc_html_e('Engines', 'seo-help'); ?></th>
                    <td>
                        <select class="custom-select" name="qcld_seohelp_ai_engines" placeholder="<?php esc_html_e('1234 Main St', 'seo-help'); ?>" >
                            <option selected=""><?php esc_html_e('Please select Engines', 'seo-help'); ?></option>

                            <option value="<?php esc_attr_e( 'gpt-4','seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'gpt-4') ? esc_attr('selected') : '') ; ?>><?php esc_html_e( 'GPT-4','seo-help');?></option>
                            <option value="<?php esc_attr_e( 'gpt-3.5-turbo','seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'gpt-3.5-turbo') ? esc_attr('selected') : '') ; ?>><?php esc_html_e( 'GPT-3 turbo','seo-help'); ?></option>
                            <option value="text-davinci-003" <?php echo (( $qcld_seohelp_ai_engines == 'text-davinci-003') ? ' selected' : ' ') ;?>><?php esc_html_e('Davinci ( GPT-3 )', 'seo-help'); ?></option>
                            <option value="<?php esc_attr_e('text-davinci-001', 'seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'text-davinci-001')? ' selected' : ' ') ;?>><?php esc_html_e('Davinci', 'seo-help'); ?></option>
                            <option value="<?php esc_attr_e('text-ada-001', 'seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'text-ada-001')? ' selected' : ' ') ;?>><?php esc_html_e('Ada', 'seo-help'); ?></option>
                            <option value="<?php esc_attr_e('text-curie-001', 'seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'text-curie-001')? ' selected' : ' ') ;?>><?php esc_html_e('Curie', 'seo-help'); ?></option>
                            <option value="<?php esc_attr_e('text-babbage-001', 'seo-help'); ?>" <?php echo (( $qcld_seohelp_ai_engines == 'text-babbage-001')? ' selected' : ' ') ;?>><?php esc_html_e('Babbag', 'seo-help'); ?></option>
                        </select>
                    </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Max token ( Min: 0, Max:4000 )', 'seo-help'); ?></th>
                        <td>
                            <input type="text" class="max_token" id="qcld_seohelp_max_token" name="qcld_seohelp_max_token" placeholder="Max token"  value="<?php echo $qcld_seohelp_max_token;?>">
                            <p class="qcld_seohelp_p"><?php esc_html_e('Depending on the model', 'seo-help'); ?></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Temperature', 'seo-help'); ?></th>
                        <td>
                            <input id="qcld_seohelp_ai_temperature" name="qcld_seohelp_ai_temperature" type="text" data-slider-min="0" data-slider-max="1.0" data-slider-step="0.1" data-slider-value="<?php echo $qcld_seohelp_ai_temperature ? $qcld_seohelp_ai_temperature : '0.5' ;?>"  value="<?php echo $qcld_seohelp_ai_temperature; ?>"/>
                            <span id="temperatureSliderValLabel"> <span id="temperatureVal"><?php echo $qcld_seohelp_ai_temperature ? $qcld_seohelp_ai_temperature : '0.5' ;?></span></span>
                            <p class="qcld_seohelp_p"><?php esc_html_e('Temperature is a value between 0 and 1 that essentially lets you control how confident the model should be when making these predictions', 'seo-help'); ?></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Presence Penalty', 'seo-help'); ?></th>
                        <td>
                            <input type="text" id="qcld_seohelp_ai_ppenalty" name="qcld_seohelp_ai_ppenalty" data-slider-min="-2" data-slider-max="2" data-slider-step="0.1" data-slider-value="<?php echo $qcld_seohelp_ai_ppenalty ? $qcld_seohelp_ai_ppenalty : '0' ;?>"  value="<?php echo $qcld_seohelp_ai_ppenalty;?>"/>
                            <span id="presence_penaltySliderValLabel"> <span id="presence_penaltyVal"><?php echo $qcld_seohelp_ai_ppenalty ? $qcld_seohelp_ai_ppenalty : '0' ;?></span></span>
                            <p class="qcld_seohelp_p"><?php esc_html_e('Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model’s likelihood to talk about new topics.', 'seo-help'); ?></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Frequency Penalty', 'seo-help'); ?></th>
                        <td>
                           <input type="text" id="qcld_seohelp_ai_fpenalty" name="qcld_seohelp_ai_fpenalty" data-slider-min="-2" data-slider-max="2" data-slider-step="0.1" data-slider-value="<?php echo $qcld_seohelp_ai_fpenalty ? $qcld_seohelp_ai_fpenalty : '0' ;?>"  value="<?php echo $qcld_seohelp_ai_fpenalty;?>" />
                            <span id="frequency_penaltySliderValLabel"> <span id="frequency_penaltyVal"><?php echo $qcld_seohelp_ai_fpenalty ? $qcld_seohelp_ai_fpenalty : '0' ;?> </span></span>
                            <p class="qcld_seohelp_p"><?php esc_html_e('Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim.', 'seo-help'); ?></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Connect to OpenAI only when user query includes one of the following Keywords', 'seo-help'); ?></th>
                        <td>
                            <textarea type="text" name="qcld_seohelp_ai_include_comments" id="qcld_seohelp_ai_include_comments"><?php echo esc_attr($qcld_seohelp_ai_include_comments); ?> </textarea>
                            <p class="qcld_seohelp_p"><?php esc_html_e('You can add multiple keywords or phrases as coma(,) seperated values. Connect to OpenAI only when user query includes one of the following Keywords.', 'seo-help'); ?></p>

                            <input type="checkbox" name="qcld_seohelp_ai_reply_question_relevant_keywords" value="1" <?php checked( $qcld_seohelp_ai_reply_question_relevant_keywords, '1' ); ?> />
                            <p class="description"><?php esc_html_e( 'Ask OpenAI to reply when question is relevant to above Keywords ', 'qc-clr' ); ?><b><?php esc_html_e( '(Enabling this option will improve accuracy but it will use OpenAI Tokens) ', 'qc-clr' ); ?></b></p><br/>

                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Connect to OpenAI only when user query does NOT include one of the following Keywords', 'seo-help'); ?></th>
                        <td>
                            <textarea type="text" name="qcld_seohelp_ai_exclude_comments" id="qcld_seohelp_ai_exclude_comments"><?php echo esc_attr($qcld_seohelp_ai_exclude_comments); ?> </textarea>
                            <p class="qcld_seohelp_p"><?php esc_html_e('You can add multiple keywords or phrases as coma(,) seperated values. Connect to OpenAI only when user query does NOT include one of the following Keywords.', 'seo-help'); ?></p>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Prompt for Comment Replier', 'seo-help'); ?></th>
                        <td>
                            <textarea rows="5" type="text" name="qcld_seohelp_ai_default_comment_prompt"><?php echo esc_html(str_replace("\\",'',$qcld_seohelp_ai_default_comment_prompt));?></textarea>
                            <p><?php echo sprintf(esc_html__('Ensure %s and %s and %s and %s and %s is included in your prompt.','gpt3-ai-content-generator'),'<code>[username]</code>','<code>[post_title]</code>','<code>[post_excerpt]</code>','<code>[last_comment]</code>','<code>[parent_comments]</code>')?></p>
                        </td>
                    </tr>

                   

                    <?php do_action( 'qcclr_more_options' ); ?>

                </table>

                <?php submit_button(); ?>

            </form>
            </div>
        <?php
        echo ob_get_clean();
        
        
    }

}

add_action( 'init', 'qcclr_comment_autoreply_save_plugin_data' );

if ( ! function_exists( 'qcclr_comment_autoreply_save_plugin_data' ) ) {
    function qcclr_comment_autoreply_save_plugin_data() {

        // Verify nonce for security.
        if (
            isset( $_POST['qcclr_autoreply_save_data_field'] )
            && wp_verify_nonce( $_POST['qcclr_autoreply_save_data_field'], 'qcclr_autoreply_data_action' )
        ) {

            $qcclr_autoreply_settings = array();

            // Get data from form.
            if ( isset( $_POST['qcclr_enable_comment_autoreply'] ) && ! empty( $_POST['qcclr_enable_comment_autoreply'] ) ) {
                $qcclr_autoreply_settings['qcclr_enable_comment_autoreply'] = intval( $_POST['qcclr_enable_comment_autoreply'] );
            }
            if ( isset( $_POST['qcld_seohelp_api_key'] ) && ! empty( $_POST['qcld_seohelp_api_key'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_api_key'] = sanitize_text_field( $_POST['qcld_seohelp_api_key'] );
            }
            if ( isset( $_POST['qcld_seohelp_ai_engines'] ) && ! empty( $_POST['qcld_seohelp_ai_engines'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_engines'] = sanitize_text_field( $_POST['qcld_seohelp_ai_engines'] );
            }

            if ( isset( $_POST['qcld_seohelp_max_token'] ) && ! empty( $_POST['qcld_seohelp_max_token'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_max_token'] = sanitize_text_field( $_POST['qcld_seohelp_max_token'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_temperature'] ) && ! empty( $_POST['qcld_seohelp_ai_temperature'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_temperature'] = sanitize_text_field( $_POST['qcld_seohelp_ai_temperature'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_ppenalty'] ) && ! empty( $_POST['qcld_seohelp_ai_ppenalty'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_ppenalty'] = sanitize_text_field( $_POST['qcld_seohelp_ai_ppenalty'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_fpenalty'] ) && ! empty( $_POST['qcld_seohelp_ai_fpenalty'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_fpenalty'] = sanitize_text_field( $_POST['qcld_seohelp_ai_fpenalty'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_include_comments'] ) && ! empty( $_POST['qcld_seohelp_ai_include_comments'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] = sanitize_text_field( $_POST['qcld_seohelp_ai_include_comments'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_exclude_comments'] ) && ! empty( $_POST['qcld_seohelp_ai_exclude_comments'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] = sanitize_text_field( $_POST['qcld_seohelp_ai_exclude_comments'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_reply_question_relevant_keywords'] ) && ! empty( $_POST['qcld_seohelp_ai_reply_question_relevant_keywords'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] = sanitize_text_field( $_POST['qcld_seohelp_ai_reply_question_relevant_keywords'] );
            }

            if ( isset( $_POST['qcld_seohelp_ai_default_comment_prompt'] ) && ! empty( $_POST['qcld_seohelp_ai_default_comment_prompt'] ) ) {
                $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] = sanitize_text_field( $_POST['qcld_seohelp_ai_default_comment_prompt'] );
            }


            $qcclr_autoreply_settings = apply_filters( 'qcclr_autoreply_settings', $qcclr_autoreply_settings );

            // Save to option table.
            update_option( 'qcclr_autoreply_settings', $qcclr_autoreply_settings );

            add_action( 'admin_notices',  'qcclr_admin_notice'  );

        }

    }
}


$qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );
// Get status.
$qcclr_enable_comment_autoreply = ! empty( $qcclr_autoreply_settings['qcclr_enable_comment_autoreply'] ) ? $qcclr_autoreply_settings['qcclr_enable_comment_autoreply'] : false;
if( $qcclr_enable_comment_autoreply == '1' ) {
add_action( 'comment_post', 'qcld_auto_replies_new_comment', 1000, 3 );
}
if ( ! function_exists( 'qcld_auto_replies_new_comment' ) ) {
    function qcld_auto_replies_new_comment( $comment_ID, $comment_approved, $commentdata ){
        $comment_parent = (int) $commentdata['comment_parent'];
        
        $comment_content    = isset( $commentdata['comment_content'] ) ? $commentdata['comment_content'] : '';
        
        // If a new comment is a reply to another comment, don't do anything
        if ( $comment_approved !== 1 ) {
            return;
        }

        $qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );
        $qcclr_enable_comment_autoreply_child = !empty( $qcclr_autoreply_settings['qcclr_enable_comment_autoreply_child'] ) ? $qcclr_autoreply_settings['qcclr_enable_comment_autoreply_child'] : false;

        $include_comments      = apply_filters('qcld_auto_replies_include_comments', $comment_content );
        $exclude_comments      = apply_filters('qcld_auto_replies_exclude_comments', $comment_content );
        
        if ( ( $comment_parent !== 0 && $qcclr_enable_comment_autoreply_child !== 1 ) || ( isset($exclude_comments) && $exclude_comments == 1 ) || ( isset($include_comments) && $include_comments == 1 ) ) {
            return;
        }


        $content_post   = get_post( $commentdata['comment_post_ID'] );
        $author_id      = isset( $content_post->post_author ) ? $content_post->post_author : 1;

        $comment_author_name    = get_the_author_meta( 'display_name', $author_id );
        // to get  email
        $comment_author_email   = get_the_author_meta( 'email', $author_id );
        // to get  url
        $comment_author_url     = get_the_author_meta( 'url', $author_id );
 
        $comment_reply      = apply_filters('qcld_auto_replies_comment_content', $comment_content, $comment_ID );

        
        if(!empty($comment_reply) && $comment_reply != 'DUH'){

            $commentdata = [
                'comment_post_ID'      => $commentdata['comment_post_ID'],
                'comment_author'       => $comment_author_name,
                'comment_author_email' => $comment_author_email,
                'comment_author_url'   => $comment_author_url,
                'comment_content'      => $comment_reply,
                'comment_type'         => 'comment',
                'comment_parent'       => $comment_ID,
                'user_ID'              => $author_id,
            ];
          
            wp_new_comment( $commentdata );

        }
    }

}

add_filter('qcld_auto_replies_comment_content', 'qcld_auto_replies_comment_content', 10, 2);
if ( ! function_exists( 'qcld_auto_replies_comment_content' ) ) {
    function qcld_auto_replies_comment_content( $keyword, $comment_ID ){


        $keyword        = isset($keyword) ? $keyword : '';
        $qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );
        $qcld_seohelp_api_key = !empty( $qcclr_autoreply_settings['qcld_seohelp_api_key'] ) ? $qcclr_autoreply_settings['qcld_seohelp_api_key'] : '';
        $qcld_seohelp_ai_engines = !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_engines'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_engines'] : '';
        $qcld_seohelp_max_token = !empty( $qcclr_autoreply_settings['qcld_seohelp_max_token'] ) ? $qcclr_autoreply_settings['qcld_seohelp_max_token'] : '';
        $qcld_seohelp_ai_temperature = !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_temperature'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_temperature'] : '';
        $qcld_seohelp_ai_ppenalty = !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_ppenalty'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_ppenalty'] : '';
        $qcld_seohelp_ai_fpenalty = !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_fpenalty'] ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_fpenalty'] : '';

        $OPENAI_API_KEY = $qcld_seohelp_api_key;
        $ai_engines     = $qcld_seohelp_ai_engines;
        $max_token      = $qcld_seohelp_max_token;
        $temperature    = $qcld_seohelp_ai_temperature;
        $ppenalty       = $qcld_seohelp_ai_ppenalty;
        $fpenalty       = $qcld_seohelp_ai_fpenalty;

        $result_data = '';

        if(!empty($keyword)){

            $qcld_seohelp_ai_reply_question_relevant_keywords = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] : '';
            $qcld_seohelp_ai_include_comments = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] : '';


            $default_comment_prompt = "Please generate a relevant and thoughtful response to [username]'s comment on the post titled '[post_title]' with the excerpt '[post_excerpt]'. The user's latest comment is: '[last_comment]'. If applicable, consider the context of the previous conversation: '[parent_comments]'. Keep the response focused on the topic and avoid creating any new information.";

            $qcld_seohelp_ai_default_comment_prompt = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_default_comment_prompt'] : $default_comment_prompt;

            $comment    = get_comment($commentID);
            $post       = get_post($comment->comment_post_ID);
            $prompt     = str_replace('[post_title]', $content_post->post_title, $qcld_seohelp_ai_default_comment_prompt);
            $prompt     = str_replace('[post_excerpt]', $post->post_excerpt, $prompt);
            $prompt     = str_replace('[username]', $comment->comment_author, $prompt);
            $prompt     = str_replace('[last_comment]', $comment->comment_content, $prompt);
            $totalWords = qcld_auto_replies_count_words($prompt);
            $prompts_comments = array();
            $prompts_final_comments = array();
            $parent_comments = array();
            if ($comment->comment_parent > 0) {
                $parentComments = qcld_auto_replies_parent_comments($comment->comment_parent, array());
                if ($parentComments && is_array($parentComments) && count($parentComments)) {
                    foreach ($parentComments as $item) {
                        $prompts_comments[] = $item->comment_author.': '.$item->comment_content;
                    }
                }
            }
            foreach($prompts_comments as $prompts_comment){
                $comment_word_count = qcld_auto_replies_count_words($prompts_comment);
                $totalWords += $comment_word_count;
                if($totalWords > 1500){
                    break;
                }
                else{
                    $prompts_final_comments[] = $prompts_comment;
                }
            }
            if(count($prompts_final_comments)){
                foreach(array_reverse($prompts_final_comments) as $prompts_final_comment){
                    $parent_comments[] = $prompts_final_comment;
                }
            }
            if(count($parent_comments)){
                $parent_comments = implode("\n",$parent_comments);
                $prompt = str_replace('[parent_comments]',$parent_comments,$prompt);
            }

            // Prompt: Provide a response only if the following query is relevant to one of the keywords: kw1, kw2..... . The actual query is as follows:
            if($qcld_seohelp_ai_reply_question_relevant_keywords == 1){
            
                //$prompt    = 'Provide a response only if the following query is relevant to one of the keywords:'.$qcld_seohelp_ai_include_comments .' if not then only say DUH. The actual query is as follows: '. $prompt;
                $prompt    = 'If  the query is not relevant  to one of the keywords: '.$qcld_seohelp_ai_include_comments .' then only say DUH. Provide a response only if the following query is relevant to one of the keywords: '.$qcld_seohelp_ai_include_comments .' The actual query is as follows: '.$keyword .'.' . $prompt;

            }else{

                $prompt    = $prompt;

            }

            $gptkeyword = [];
            if($ai_engines == 'gpt-3.5-turbo' || $ai_engines == 'gpt-4'){
                $ch     = curl_init();
                $url    = 'https://api.openai.com/v1/chat/completions';

                array_push($gptkeyword, array(
                           "role" => "user",
                           "content" =>  $prompt
                        ));

                $post_fields = array(
                    "model"         => $ai_engines,
                    "messages"      => $gptkeyword,
                    "max_tokens"    => 200,
                    "temperature"   => 0
                );
                $header  = [
                    'Content-Type: application/json',
                    'Authorization: Bearer ' . $OPENAI_API_KEY
                ];
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($post_fields));
                curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
                $result = curl_exec($ch);
                if (curl_errno($ch)) {
                    echo 'Error: ' . curl_error($ch);
                }
                curl_close($ch);

                $results    = json_decode($result);

                $result_data = isset( $results->choices[0]->message->content ) ? trim( $results->choices[0]->message->content ) : '';

                return $result_data;

            }else{

                $request_body = [
                    "prompt"            => $prompt,
                    "model"             =>  'text-davinci-003',
                    "max_tokens"        => (int)$max_token,
                    "temperature"       => (float)$temperature,
                    "presence_penalty"  => (float)$ppenalty,
                    "frequency_penalty" => (float)$fpenalty,
                    "top_p"             => 1,
                    "best_of"           => 1,
                ];

                $data    = json_encode($request_body);
                $url     = "https://api.openai.com/v1/completions";
                $apt_key = "Authorization: Bearer ". $OPENAI_API_KEY;

                $curl = curl_init($url);
                curl_setopt($curl, CURLOPT_URL, $url);
                curl_setopt($curl, CURLOPT_POST, true);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                $headers    = array(
                   "Content-Type: application/json",
                   $apt_key ,
                );
                curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
                $result     = curl_exec($curl);
                curl_close($curl);
                $results    = json_decode($result);

                $result_data = isset( $results->choices[0]->text ) ? trim( $results->choices[0]->text ) : '';

                return $result_data;


            }

        }
    
        return '';
        

    }
}

if ( ! function_exists( 'qcld_auto_replies_parent_comments' ) ) {
    function qcld_auto_replies_parent_comments($id, $comments){

        $comment = get_comment($id);
        if($comment){
            $comments[] = $comment;
            if($comment->comment_parent > 0){
                $comments = qcld_auto_replies_parent_comments($comment->comment_parent,$comments);
            }
        }
        return $comments;
    }
}

if ( ! function_exists( 'qcld_auto_replies_count_words' ) ) {
    function qcld_auto_replies_count_words($text){

        $text = trim(strip_tags(html_entity_decode($text,ENT_QUOTES)));
        $text = preg_replace("/[\n]+/", " ", $text);
        $text = preg_replace("/[\s]+/", "@SEPARATOR@", $text);
        $text_array = explode('@SEPARATOR@', $text);
        $count = count($text_array);
        $last_key = end($text_array);
        if (empty($last_key)) {
            $count--;
        }
        return $count;
    }
}

// include comments by keywords or phrase
add_filter('qcld_auto_replies_include_comments', 'qcld_auto_replies_include_comments', 10, 1);
if ( ! function_exists( 'qcld_auto_replies_include_comments' ) ) {
    function qcld_auto_replies_include_comments( $keyword ){


        $keyword = isset($keyword) ? $keyword : '';

        if(!empty($keyword)){
            $qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );
            $qcld_seohelp_ai_include_comments = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_include_comments'] : '';
            $qcld_seohelp_ai_reply_question_relevant_keywords = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_reply_question_relevant_keywords'] : '';

            if( !empty($qcld_seohelp_ai_include_comments) && $qcld_seohelp_ai_reply_question_relevant_keywords !== 1 ){

                $include_items = explode(',', $qcld_seohelp_ai_include_comments);

                if(!empty($include_items)){

                    foreach($include_items as $item){

                        if(strpos($keyword,trim($item)) !== false){
                            return false;
                        }

                    }

                }

                return true;

            }
          

        }
    
        return false;

    }
}

// exclude comments by keywords or phrase
add_filter('qcld_auto_replies_exclude_comments', 'qcld_auto_replies_exclude_comments', 10, 1);
if ( ! function_exists( 'qcld_auto_replies_exclude_comments' ) ) {
    function qcld_auto_replies_exclude_comments( $keyword ){


        $keyword = isset($keyword) ? $keyword : '';

        if(!empty($keyword)){
            $qcclr_autoreply_settings = get_option( 'qcclr_autoreply_settings' );
            $qcld_seohelp_ai_exclude_comments = ( isset( $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] ) && !empty( $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] ) ) ? $qcclr_autoreply_settings['qcld_seohelp_ai_exclude_comments'] : '';

            if(!empty($qcld_seohelp_ai_exclude_comments)){

                $exclude_items = explode(',',$qcld_seohelp_ai_exclude_comments);

                if(!empty($exclude_items)){

                    foreach($exclude_items as $item){

                        if(strpos($keyword,trim($item)) !== false){
                            return true;
                        }

                    }

                }

            }

          

        }
    
        return false;

    }
}



function qc_clr_dmin_autoreply_scripts(){

    if( isset($_GET["page"]) && !empty($_GET["page"]) &&  (   $_GET["page"] == "qcclr_comment_autoreply" ) ){
        //Styles
        wp_enqueue_style( 'qcclr_admin_autoreply_css', qcclr_pro_ASSETS_URL . "/css/qc-clr-autoreply.css");

        //Scripts
        wp_enqueue_script( 'jquery', 'jquery');


        wp_enqueue_script('qcld_clr_slider', qcclr_pro_ASSETS_URL. '/js/qcld_clr_slider.min.js');
        wp_enqueue_script('qcld_autoreply_script', qcclr_pro_ASSETS_URL. '/js/qcld_autoreply_script.js', true );

    }



}
add_action( 'admin_enqueue_scripts', 'qc_clr_dmin_autoreply_scripts');

