<?php

defined('ABSPATH') or die("No direct script access!");


function qcclr_comment_mention_admin_settings(){

    ob_start();

    $qcclr_settings = get_option( 'qcclr_settings' );

    // Get status.
    $qcclr_enable_comment_mention = ! empty( $qcclr_settings['qcclr_enable_comment_mention'] ) ? $qcclr_settings['qcclr_enable_comment_mention'] : false;
    $qcclr_enable_comment_mention_comment = ! empty( $qcclr_settings['qcclr_enable_comment_mention_comment'] ) ? $qcclr_settings['qcclr_enable_comment_mention_comment'] : false;

    $qcclr_email_enable = ! empty( $qcclr_settings['qcclr_email_enable'] ) ? $qcclr_settings['qcclr_email_enable'] : false;
    // Get subject.
    $qcclr_subject = ! empty( $qcclr_settings['qcclr_email_subject'] ) ? $qcclr_settings['qcclr_email_subject'] : qcclr_mail_subject();
    // Get content.
    $qcclr_mail_content = ! empty( $qcclr_settings['qcclr_mail_content'] ) ? $qcclr_settings['qcclr_mail_content'] : qcclr_default_mail_content();
    // Get Selected.
    $qcclr_enabled_user_roles = ! empty( $qcclr_settings['qcclr_enabled_user_roles'] ) ? $qcclr_settings['qcclr_enabled_user_roles'] : array();

    ?>
    <style>
        .form-table td p.description {
            display: inline;
        }
    </style>
        <div class="wrap">
        <h1><?php esc_html_e( 'Comment Mention Settings', 'qc-clr' ); ?></h1>

        <form method="post" action="">
            <?php wp_nonce_field( 'qcclr_save_data_action', 'qcclr_save_data_field' ); ?>
            <table class="form-table">

                <tr valign="top">
                <th scope="row"><?php esc_html_e( 'Enabled Comment Mention', 'qc-clr' ); ?></th>
                <td>
                    <input type="checkbox" name="qcclr_enable_comment_mention" value="1" <?php checked( $qcclr_enable_comment_mention, '1' ); ?> />
                    <p class="description"><?php esc_html_e( 'Enable comment mention for Mention Users.', 'qc-clr' ); ?><br/>
                </td>
                </tr>

                <tr valign="top">
                <th scope="row"><?php esc_html_e( 'Enabled Content Mention', 'qc-clr' ); ?></th>
                <td>
                    <input type="checkbox" name="qcclr_enable_comment_mention_comment" value="1" <?php checked( $qcclr_enable_comment_mention_comment, '1' ); ?> />
                    <p class="description"><?php esc_html_e( 'Enable comment Mention for comment content.', 'qc-clr' ); ?><br/>
                </td>
                </tr>

                <tr valign="top">
                <th scope="row"><?php esc_html_e( 'Enable Emails', 'qc-clr' ); ?></th>
                <td>
                    <input type="checkbox" name="qcclr_email_enable" value="1" <?php checked( $qcclr_email_enable, '1' ); ?> />
                    <p class="description"><?php esc_html_e( 'Whether to send email to mentioned user or not.', 'qc-clr' ); ?><br/>
                </td>
                </tr>

                <tr valign="top">
                <th scope="row"><?php esc_html_e( 'Email Subject', 'qc-clr' ); ?></th>
                <td>
                    <input type="text" name="qcclr_email_subject" value="<?php echo esc_attr( $qcclr_subject ); ?>" style="min-width: 350px;" />
                    <p class="description"><?php esc_html_e( 'Subject for mentioned user email.', 'qc-clr' ); ?><br/>
                </td>
                </tr>

                <tr valign="top">
                <th scope="row"><?php esc_html_e( 'Email Content', 'qc-clr' ); ?></th>
                <td>
                    <?php

                        $editor_id = 'qcclr_mail_content';
                        $settings  = array(
                            'media_buttons' => false,
                        );

                        wp_editor( wp_kses_post( $qcclr_mail_content ), $editor_id, $settings );
                    ?>
                    <p class="description"><?php esc_html_e( 'Mail content for mentioned user email. Available shortcodes:', 'qc-clr' ); ?><br/>
                    <strong>#comment_link#</strong>&nbsp;-&nbsp;<?php esc_html_e( 'Link where user is mentioned.', 'qc-clr' ); ?><br/>
                    <strong>#post_name#</strong>&nbsp;-&nbsp;<?php esc_html_e( 'Post title where user is mentioned.', 'qc-clr' ); ?><br/>
                    <strong>#user_name#</strong>&nbsp;-&nbsp;<?php esc_html_e( 'Username who is mentioned.', 'qc-clr' ); ?><br/>
                    <strong>#commenter_name#</strong>&nbsp;-&nbsp;<?php esc_html_e( 'Commenter name.', 'qc-clr' ); ?><br/>
                    <strong>#comment_content#</strong>&nbsp;-&nbsp;<?php esc_html_e( 'Comment content.', 'qc-clr' ); ?><br/>
                    </p>
                </td>
                </tr>

                <?php do_action( 'qcclr_more_options' ); ?>

            </table>

            <?php submit_button(); ?>

        </form>
        </div>
    <?php
    echo ob_get_clean();
    
    
}

add_action( 'init', 'qcclr_save_plugin_data' );

function qcclr_save_plugin_data() {

    // Verify nonce for security.
    if (
        isset( $_POST['qcclr_save_data_field'] )
        && wp_verify_nonce( $_POST['qcclr_save_data_field'], 'qcclr_save_data_action' )
    ) {

        $qcclr_settings = array();

        // Get data from form.
        if ( isset( $_POST['qcclr_enable_comment_mention'] ) && ! empty( $_POST['qcclr_enable_comment_mention'] ) ) {
            $qcclr_settings['qcclr_enable_comment_mention'] = intval( $_POST['qcclr_enable_comment_mention'] );
        }
        if ( isset( $_POST['qcclr_enable_comment_mention_comment'] ) && ! empty( $_POST['qcclr_enable_comment_mention_comment'] ) ) {
            $qcclr_settings['qcclr_enable_comment_mention_comment'] = intval( $_POST['qcclr_enable_comment_mention_comment'] );
        }
        if ( isset( $_POST['qcclr_email_enable'] ) && ! empty( $_POST['qcclr_email_enable'] ) ) {
            $qcclr_settings['qcclr_email_enable'] = intval( $_POST['qcclr_email_enable'] );
        }

        if ( isset( $_POST['qcclr_email_subject'] ) && ! empty( $_POST['qcclr_email_subject'] ) ) {
            $qcclr_settings['qcclr_email_subject'] = sanitize_text_field( $_POST['qcclr_email_subject'] );
        }

        if ( isset( $_POST['qcclr_mail_content'] ) && ! empty( $_POST['qcclr_mail_content'] ) ) {
            $qcclr_settings['qcclr_mail_content'] = wp_kses_post( wp_kses_stripslashes( $_POST['qcclr_mail_content'] ) );
        }

        //$qcclr_settings['qcclr_enabled_user_roles'] = filter_input( INPUT_POST, 'qcclr_enabled_user_roles', FILTER_DEFAULT, FILTER_REQUIRE_ARRAY );

        $qcclr_settings = apply_filters( 'qcclr_settings', $qcclr_settings );

        // Save to option table.
        update_option( 'qcclr_settings', $qcclr_settings );

        add_action( 'admin_notices',  'qcclr_admin_notice'  );

    }

}

function qcclr_admin_notice() {
    ?>
    <div class="notice notice-success is-dismissible">
        <p><?php esc_html_e( 'Seetings Saved', 'comment-mention' ); ?></p>
    </div>
    <?php
}


// Ger users.
add_action( 'wp_ajax_qcclr_get_users', 'qcclr_ajax_get_users' );
add_action( 'wp_ajax_nopriv_qcclr_get_users', 'qcclr_ajax_get_users' );

/**
 * Get usernames.
 */
function qcclr_ajax_get_users() {

	// Set arguments.
	$args = array(
		'term' => sanitize_text_field( $_GET['term'] ),
	);

	do_action( 'qcclr_ajax_before_get_users', $args );

	// Get usernames.
	$results = apply_filters( 'qcclr_ajax_get_users', qcclr_get_users( $args['term'] ), $args );

	do_action( 'qcclr_ajax_after_get_users', $results, $args );

	// Send response as json.
	if ( is_wp_error( $results ) ) {
		wp_send_json_error( $results->get_error_message() );
		exit;
	}

	wp_send_json_success( $results );
}
function qcclr_get_users( $username ) {

	$wp_user_query = new WP_User_Query(
		apply_filters(
			'qcclr_get_users_args',
			array(
				'search'         => $username . '*',
				'search_columns' => array( 'user_login' ),
			)
		)
	);

	$found_users = apply_filters( 'qcclr_found_users', $wp_user_query->get_results() );
	$results     = array();

	if ( ! empty( $found_users ) ) {

		foreach ( $found_users as $user ) {

			$fname = get_user_meta( $user->ID, 'first_name', true );
			$lname = get_user_meta( $user->ID, 'last_name', true );

			$fullname = array();

			if ( ! empty( $fname ) ) {
				$fullname[] = $fname;
			}

			if ( ! empty( $lname ) ) {
				$fullname[] = $lname;
			}

			$user_full_name = '';

			if ( ! empty( $fullname ) ) {
				$user_full_name = implode( ' ', $fullname );
			}

			$result                = new stdClass();
			$result->user_login    = $user->user_login;
			$result->user_nicename = $user->user_nicename;
			$result->image         = get_avatar_url( $user->ID );
			$result->name          = ! empty( $user_full_name ) ? $user_full_name : $user->user_nicename;
			$result->user_id       = $user->ID;

			$results[] = $result;
		}
	}

	return apply_filters( 'qcclr_user_results', $results );

}

function qcclr_enqueue_script_callback() {


	$qcclr_settings 				= get_option( 'qcclr_settings' );
	$qcclr_enable_comment_mention 	= ! empty( $qcclr_settings['qcclr_enable_comment_mention'] ) ? $qcclr_settings['qcclr_enable_comment_mention'] : false;

	if( $qcclr_enable_comment_mention ){

		wp_enqueue_style('qcclr-clr-css', qcclr_pro_ASSETS_URL . '/css/qc-clr-comment-mention.css' );

		// Plugin script.
		wp_enqueue_script( 'qcclr-mentions', qcclr_pro_ASSETS_URL . '/js/qcld-comment-mention.js', array( 'jquery' ) );

		$qcclr_vars = apply_filters(
			'qcclr_vars',
			array(
				'ajaxurl'            	=> admin_url( 'admin-ajax.php' ),
				'mention_result_tlp' 	=> '<li data-value="@${user_login}"><span class="username">@${user_login}</span></li>',
				'qcclr_nounce'    		=> wp_create_nonce( 'qcclr-nounce' ),
			)
		);

		// Set ajax URL.
		wp_localize_script(
			'qcclr-mentions',
			'Comment_Mention',
			$qcclr_vars
		);

	}

}
add_action('wp_enqueue_scripts', 'qcclr_enqueue_script_callback');



// Modify comment content.
add_filter( 'pre_comment_content',  'qcclr_at_name_filter', 999 );

function qcclr_at_name_filter( $content ) {

	// Try to find mentions.
	$usernames = qcclr_find_mentions( $content );

	// If no mentions found, then halt the process.
	if ( empty( $usernames ) ) {
		return $content;
	}

	// We don't want to link @mentions that are inside of links, so we
	// temporarily remove them.
	$replace_count = 0;
	$replacements  = array();
	foreach ( $usernames as $username ) {
		// Prevent @ name linking inside <a> tags.
		preg_match_all( '/(<a.*?(?!<\/a>)@' . $username . '.*?<\/a>)/', $content, $content_matches );
		if ( ! empty( $content_matches[1] ) ) {
			foreach ( $content_matches[1] as $replacement ) {
				$replacements[ '#BPAN' . $replace_count ] = $replacement;
				$content                                  = str_replace( $replacement, '#BPAN' . $replace_count, $content );
				$replace_count++;
			}
		}
		
	}

	// Linkify the mentions with the username.
	foreach ( (array) $usernames as $user_id => $username ) {
		$author_url = get_author_posts_url( $user_id );
		$content    = preg_replace( '/(@' . $username . '\b)/', "<a class='qc-clr-comment-mention' href='$author_url' rel='nofollow'>@$username</a>", $content );
	}

	// Put everything back.
	if ( ! empty( $replacements ) ) {
		foreach ( $replacements as $placeholder => $original ) {
			$content = str_replace( $placeholder, $original, $content );
		}
	}

	// Return the content.
	return apply_filters( 'qcclr_at_name_filter', $content );
}

// Process comment.
add_action( 'comment_post',  'qcclr_preprocess_comment', 10, 3 );

function qcclr_preprocess_comment( $comment_ID, $comment_status, $comment_data ) {

	$qcclr_settings 				= get_option( 'qcclr_settings' );
	$qcclr_enable_comment_mention 	= ! empty( $qcclr_settings['qcclr_enable_comment_mention'] ) ? $qcclr_settings['qcclr_enable_comment_mention'] : false;
	$is_send_email_enabled 			= ! empty( $qcclr_settings['qcclr_email_enable'] ) ? $qcclr_settings['qcclr_email_enable'] : false;
	

	if ( ! $qcclr_enable_comment_mention && ! $is_send_email_enabled  ) {
		return;
	}

	if ( ! current_user_can( 'manage_options' ) )
        return;

	// Get content.
	$content = $comment_data['comment_content'];

	// Add data to array for post use.
	$comment_data['comment_ID'] = $comment_ID;

	// Get usernames from comment content.
	$usernames = qcclr_find_mentions( $content );

	// Iterate the username loop.
	if(!empty($usernames)){
		foreach ( $usernames as $username ) {

			// Get user id.
			$uid = username_exists( $username );

			if ( $uid ) {

				// Get user data.
				$qcclr_user_data                  		= get_user_by( 'id', $uid );
				$comment_data['mentioned_user_data'] 	= $qcclr_user_data;

				// Get Mentioned User's id.
				$qcclr_user_id = $qcclr_user_data->ID;
				if ( 0 !== $qcclr_user_id ) {
					// Check If User Turned Off Email Notification or not.

					$qcclr_email_enabled = ! empty( get_user_meta( $qcclr_user_id, 'qcclr_email_notification_status', true ) ) ? get_user_meta( $qcclr_user_id, 'qcclr_email_notification_status', true ) : 'false';
					if ( ! empty( $qcclr_email_enabled ) && $qcclr_email_enabled === 'true' ) {
						return;
					}
				}

				// Get email body.
				$qcclr_mail_body = qcclr_mail_body( $comment_data );
				$qcclr_mail_sub  = qcclr_mail_subject();

				// Set headers.
				$headers[] = 'Content-Type: text/html; charset=UTF-8';

				// Set mail as HTML format.
				add_filter(
					'wp_mail_content_type',
					function() {
						return 'text/html';
					}
				);

				// Send mail.
				wp_mail(
					esc_html( $qcclr_user_data->user_email ),
					esc_html( $qcclr_mail_sub ),
					wp_kses_post( $qcclr_mail_body ),
					$headers
				);

			}
		}
	}

}


function qcclr_find_mentions( $content ) {

	$pattern = '/[@]+([A-Za-z0-9-_\.@]+)\b/';
	preg_match_all( $pattern, $content, $usernames );

	// Make sure there's only one instance of each username.
	$usernames = array_unique( $usernames[1] );

	// Bail if no usernames.
	if ( empty( $usernames ) ) {
		return false;
	}

	$mentioned_users = array();

	// We've found some mentions! Check to see if users exist.
	foreach ( (array) array_values( $usernames ) as $username ) {

		// Get user info by login.
		$user_obj = get_user_by( 'login', $username );

		if ( empty( $user_obj ) ) {
			continue;
		}

		$user_id = intval( $user_obj->ID );

		// The user ID exists, so let's add it to our array.
		if ( ! empty( $user_id ) ) {
			$mentioned_users[ $user_id ] = $username;
		}
	}

	if ( empty( $mentioned_users ) ) {
		return false;
	}

	return $mentioned_users;
}


function qcclr_mail_body( $comment_data ) {

	$qcclr_settings = get_option( 'qcclr_settings' );

	// Get current comment link.
	$qcclr_comment_link = get_permalink( $comment_data['comment_post_ID'] ) . '#comment-' . $comment_data['comment_ID'];

	// Get post name related to that comment.
	$post_name = get_the_title( $comment_data['comment_post_ID'] );

	// Get mentioned user's display name.
	$user_name = $comment_data['mentioned_user_data']->display_name;

	$mail_content = ! empty( $qcclr_settings['qcclr_mail_content'] ) ? $qcclr_settings['qcclr_mail_content'] : '';

	if ( empty( $mail_content ) ) {
		$mail_content = qcclr_default_mail_content();
	}

	$commenter_name  = isset( $comment_data['comment_author'] )
		? $comment_data['comment_author']
		: esc_html__( 'Someone', 'comment-mention' );
	$comment_content = isset( $comment_data['comment_content'] )
		? $comment_data['comment_content']
		: '';

	$search = apply_filters(
		'qcclr_search_email_placeholders',
		array(
			'#comment_link#',
			'#post_name#',
			'#user_name#',
			'#commenter_name#',
			'#comment_content#',
		)
	);

	$replace = apply_filters(
		'qcclr_replace_email_placeholders',
		array(
			esc_url( $qcclr_comment_link ),
			esc_html( $post_name ),
			esc_html( $user_name ),
			esc_html( $commenter_name ),
			$comment_content,
		)
	);

	$mail_content = str_replace( $search, $replace, $mail_content );

	return apply_filters( 'qcclr_mail_body', $mail_content );
}



function qcclr_mail_subject() {

	$qcclr_settings = get_option( 'qcclr_settings' );

    // Get subject from settings.
    $subject = ! empty( $qcclr_settings['qcclr_email_subject'] ) ? $qcclr_settings['qcclr_email_subject'] : '';

    // If no subject is set, then return default.
    if ( empty( $subject ) ) {

        $subject = esc_html( 'You were mentioned in a comment', 'comment-mention' );

    }

    // Return subject.
    return apply_filters( 'qcclr_mail_body', $subject );
}

function qcclr_default_mail_content() {

    $content = 'Hi, <strong>#user_name#,</strong>

                Someone mentioned you in a post. See the details below:

                <a href="#comment_link#"><strong>#post_name#</strong></a>';

    return apply_filters( 'qcclr_mail_body', $content );
}


$qcclr_settings 				= get_option( 'qcclr_settings' );
$qcclr_enable_comment_mention_comment 	= ! empty( $qcclr_settings['qcclr_enable_comment_mention_comment'] ) ? $qcclr_settings['qcclr_enable_comment_mention_comment'] : false;

if( $qcclr_enable_comment_mention_comment ){

	add_filter( 'pre_comment_content',  'qcclr_at_mention_filter', 10 );


	function qcclr_at_mention_filter( $content ) {

		// Try to find mentions.
		//$contents = $content;
		$contents = qcclr_find_mentions_contents( $content );

		// If no mentions found, then halt the process.
		if ( empty( $contents ) ) {
			return $content;
		}

		// We don't want to link @mentions that are inside of links, so we
		// temporarily remove them.
		$replace_count = 0;
		$replacements  = array();
		foreach ( $contents as $data ) {
			// Prevent # name linking inside <div> tags.
			preg_match_all( '/(<div.*?(?!<\/div>)' . $data . '.*?<\/div>)/', $content, $content_matches );
			if ( ! empty( $content_matches[1] ) ) {
				foreach ( $content_matches[1] as $replacement ) {
					$replacements[ '#BPANS' . $replace_count ] = $replacement;
					$content                                  = str_replace( $replacement, '#BPANS' . $replace_count, $content );
					$replace_count++;
				}
			}
			
		}

		foreach ( (array) $contents as $data ) {
			$find_commentID = qcclr_find_mentions_commenter( $data );

			if(!empty($find_commentID)){
				$comment 		= get_comment( $find_commentID );
				$comment_author = $comment->comment_author;
				$author_url 	= get_comment_author_url( $find_commentID );
				$content    	= preg_replace( '/(#' . $data . '\D)/', "<div class='qc-clr-comment-mention-wrap'><a class='qc-clr-comment-auth' href='$author_url' rel='nofollow'>@$comment_author</a>$data</div>", $content );

			}
			//var_dump( $data );
			//var_dump( $content );
			//var_dump( $find_commentID );
			//wp_die();
			$pattern 		= '/#/i';
			$content    	= preg_replace($pattern, '', $content);
		}


		// Put everything back.
		if ( ! empty( $replacements ) ) {
			foreach ( $replacements as $placeholder => $original ) {
				$content = str_replace( $placeholder, $original, $content );
			}
		}

		// Return the content.
		return apply_filters( 'qcclr_at_mention_filter', $content );
	}


	function qcclr_find_mentions_contents( $content ) {

		//$pattern = '/[#]+([A-Za-z0-9-_\.#]+)\b/';
		$pattern = '/#(.*?)#/';

		preg_match_all( $pattern, $content, $content_datas );

		// Make sure there's only one instance of each username.
		$content_datas = array_unique( $content_datas[1] );

		// Bail if no usernames.
		if ( empty( $content_datas ) ) {
			return false;
		}

		$mentioned_contents = array();

		// We've found some mentions! Check to see if users exist.
		foreach ( (array) array_values( $content_datas ) as $key => $data ) {

			$mentioned_contents[$key] = strip_tags($data);
		}

		if ( empty( $mentioned_contents ) ) {
			return false;
		}

		return $mentioned_contents;
	}

	function qcclr_find_mentions_commenter( $data ) {

		$comments_query = new WP_Comment_Query;     
		$comments = $comments_query->query( $args ); 

		if ( $comments ) {       
			foreach ( $comments as $comment ) {         
				// display commnets       
				if (stripos(strip_tags($comment->comment_content), $data) !== false) {
				    return $comment->comment_ID;
				}
			}     
		} 

		return false;
	}


}