<?php

/*
* Comments Like Dislike
* A simple module to add like dislike for comments
* By QuantumCloudClr
*/

if ( !class_exists( 'CLR_Comments_Like' ) ) {
	class CLR_Comments_Like{
		
		function __construct(){
			add_action('init', array($this, 'main_action'));
			add_action('wp_ajax_qc_clr_like_dislike', array($this, 'qc_clr_like_dislike')); // ajax for logged in users
			add_action('wp_ajax_nopriv_qc_clr_like_dislike', array($this, 'qc_clr_like_dislike')); // ajax for not logged in users
		}
		public function main_action(){
			global $clr_options;
			if(isset($clr_options['like_dislike']) && $clr_options['like_dislike']==='1'){
				add_filter( 'comment_text', array( $this, 'comments_like_dislike' ), 200, 2 );
				add_action( 'wp_head', array( $this, 'custom_styles' ) );
				add_action( 'clr_like_dislike_output', array( $this, 'clr_like_dislike_output' ) , 100, 2 );
			}
			if(isset($clr_options['enable_emotions']) && $clr_options['enable_emotions']==='1'){
				add_filter( 'comment_text', array( $this, 'comments_enable_emotions' ), 200, 2 );
				add_action( 'wp_head', array( $this, 'custom_styles' ) );
				add_action( 'clr_enable_emotions', array( $this, 'clr_enable_emotions' ) , 10, 2 );
			}
			
		}
		public function comments_like_dislike($comment_text, $comment){
			/**
             * Don't implement on admin section
             *
             * @since 1.0.0
             */
			 
			 
			 
			if ( is_admin() ) {
                return $comment_text;
            }
			
			ob_start();

            /**
             * Fires while generating the like dislike html
             *
             * @param type string $comment_text
             * @param type array $comment
             *
             * @since 1.0.0
             */
            do_action( 'clr_like_dislike_output', $comment_text, $comment );

            $like_dislike_html = ob_get_contents();
			ob_end_clean();
			
			return $comment_text.$like_dislike_html;
		}
		
		public function comments_enable_emotions($comment_text, $comment){
			/**
             * Don't implement on admin section
             *
             * @since 1.0.0
             */
			 
			 
			 
			if ( is_admin() ) {
                return $comment_text;
            }
			
			ob_start();

            /**
             * Fires while generating the like dislike html
             *
             * @param type string $comment_text
             * @param type array $comment
             *
             * @since 1.0.0
             */
            do_action( 'clr_enable_emotions', $comment_text, $comment );

            $like_dislike_html = ob_get_contents();
			ob_end_clean();
			
			return $like_dislike_html.$comment_text;
		}
		public function clr_enable_emotions($comment_text, $comment){
			$commentCategory = get_comment_meta($comment->comment_ID, 'comment_sentiment_category', true);
			$commentScore = get_comment_meta($comment->comment_ID, 'comment_sentiment_score', true);
			
			switch($commentCategory){
				case 'neu':
					echo '<div class="emojy-container emojy-neutral"></div>';
					break;
				case 'pos':
					echo '<div class="emojy-container emojy-happy"></div>';
					break;
				case 'neg':
					echo '<div class="emojy-container emojy-angry"></div>';
					break;
			}
		}
		public function clr_like_dislike_output($comment_text, $comment){
				
			?>
				<div class="clr_comment_thumbs_wraper">
				
					<div class="clr_comment_like" id="clr_like_<?php echo $comment->comment_ID; ?>">
						<span class="clr_common clr_like" data-comment-id="<?php echo $comment->comment_ID; ?>"><i class="fas fa-thumbs-up"></i></span>
						<span class="clr_like_count"><?php echo (get_comment_meta($comment->comment_ID, 'comment_like', true)?get_comment_meta($comment->comment_ID, 'comment_like', true):0); ?></span>
					</div>
					<div class="clr_comment_dislike" id="clr_dislike_<?php echo $comment->comment_ID; ?>">
						<span class="clr_common clr_dislike" data-comment-id="<?php echo $comment->comment_ID; ?>"><i class="fas fa-thumbs-down"></i></span>
						<span class="clr_dislike_count"><?php echo (get_comment_meta($comment->comment_ID, 'comment_dislike', true)?get_comment_meta($comment->comment_ID, 'comment_dislike', true):0); ?></span>
					</div>
				
				</div>
			<?php
		}
		
		public function custom_styles(){
			
		}
		
		public function qc_clr_like_dislike(){
			
			$comment_id = $_POST['comment_id'];
			$context = $_POST['context'];
			//default ojbect
			
			$data['like'] = (int)(get_comment_meta($comment_id, 'comment_like', true)?get_comment_meta($comment_id, 'comment_like', true):0);
			$data['dislike'] = (int)(get_comment_meta($comment_id, 'comment_dislike', true)?get_comment_meta($comment_id, 'comment_dislike', true):0);
			$data['status'] = 'fail';
			
			if($comment_id==''){
				echo json_encode($data);
				die();
			}
			
			//If already liked
			if(isset($_COOKIE['clr_vote'][$comment_id]) && $_COOKIE['clr_vote'][$comment_id] == 'like' ){
				if($context=='dislike'){
					$likes = (int)get_comment_meta($comment_id, 'comment_like', true);
					$likes = $likes - 1;
					update_comment_meta( $comment_id, 'comment_like', (int)$likes );
					$dislike = (int)get_comment_meta($comment_id, 'comment_dislike', true);
					$dislike = $dislike + 1;
					update_comment_meta( $comment_id, 'comment_dislike', (int)$dislike );

					setcookie("clr_vote[$comment_id]", $context, time() + (86400 * 7), "/");
				}
			}
			//If already disliked
			if(isset($_COOKIE['clr_vote'][$comment_id]) && $_COOKIE['clr_vote'][$comment_id]=='dislike'){
				if($context=='like'){
					$likes = (int)get_comment_meta($comment_id, 'comment_dislike', true);
					$likes = $likes - 1;
					update_comment_meta( $comment_id, 'comment_dislike', (int)$likes );
					$dislike = (int)get_comment_meta($comment_id, 'comment_like', true);
					$dislike = $dislike + 1;
					update_comment_meta( $comment_id, 'comment_like', (int)$dislike );
					setcookie("clr_vote[$comment_id]", $context, time() + (86400 * 7), "/");
				}
			}
			
			if(!isset($_COOKIE['clr_vote'][$comment_id])){
				
				if($context=='like'){
					$like = (int)get_comment_meta($comment_id, 'comment_like', true);
					$like = $like + 1;
					update_comment_meta( $comment_id, 'comment_like', (int)$like );
					setcookie("clr_vote[$comment_id]", $context, time() + (86400 * 7), "/");
				}
				
				if($context=='dislike'){
					$like = (int)get_comment_meta($comment_id, 'comment_dislike', true);
					$like = $like + 1;
					update_comment_meta( $comment_id, 'comment_dislike', (int)$like );
					setcookie("clr_vote[$comment_id]", $context, time() + (86400 * 7), "/");
				}
				
			}
			
			
			$data['like'] = (int)(get_comment_meta($comment_id, 'comment_like', true)?get_comment_meta($comment_id, 'comment_like', true):0);
			
			$data['dislike'] = (int)(get_comment_meta($comment_id, 'comment_dislike', true)?get_comment_meta($comment_id, 'comment_dislike', true):0);
			
			$data['status'] = 'success';
			$data['cookies'] = $_COOKIE['clr_vote'];
			
			echo json_encode($data);			
			die();
		}
		
	}
	new CLR_Comments_Like();
}

