<?php
function qcclr_propro_show_empty_license_notification_on_plugin_row( $plugin_file, $plugin_data, $status ) {
	
	$qcld_renew_subscription = get_qcclr_pro_renew_transient();

	if( !get_qcclr_pro_license_purchase_code() ){		
		$params = array(
					'body' => array(
						'action'       => 'info',
						'plugin-slug'  => qcclr_pro_LICENSING_PLUGIN_SLUG,
					),
				);
		$request = wp_remote_post(qcclr_pro_LICENSING_REMOTE_PATH, $params, array('timeout' => 60) );

		$remote_data = '';
		if ( !is_wp_error( $request ) || wp_remote_retrieve_response_code( $request ) === 200 ) {
			$remote_data = unserialize( $request['body'] );
			$get_plugin_data = get_qcclr_pro_licensing_plugin_data();

			$plugin_current_version = $get_plugin_data['Version'];
			
			if ( $remote_data && version_compare( $plugin_current_version, $remote_data->new_version, '<' ) ) {
				echo '<tr class="plugin-update-tr qcclr_pro-empty-license">
			  			<td colspan="3" class="plugin-update colspanchange">
				        	<div class="update-message notice inline notice-warning notice-alt">
				        		<p>There is a new version available. <a href="'.esc_url('https://www.ultrawebmedia.com/li/plugins/express-shop-pro/changelog.txt').'" target="_blank">View version details</a>. Automatic update is unavailable for this plugin. To receive automatic updates, valid license is required.Updates are crucial for compatibility and security.</p>
				        	</div>
				        </td>
				    </tr>';
			}
		}
	}
}
add_action("after_plugin_row_".qcclr_pro_LICENSING_PLUGIN_SLUG, 'qcclr_propro_show_empty_license_notification_on_plugin_row', 9, 3 );

function qcclr_pro_activate_au()
{
	$plugin_slug = qcclr_pro_LICENSING_PLUGIN_SLUG;
	$get_plugin_data = get_qcclr_pro_licensing_plugin_data();

	$plugin_current_version = $get_plugin_data['Version'];
	$plugin_remote_path =  qcclr_pro_LICENSING_REMOTE_PATH;
	$license_key = get_qcclr_pro_licensing_key();
	$buy_from = get_qcclr_pro_licensing_buy_from();
	//6076-qcldpl-4784-1553173833
	//error_log($buy_from.' buy_from');
	if( $buy_from == 'quantumcloud' ){
		$upgrader_instance = new qcclr_pro_AutoUpdate ( $plugin_current_version, $plugin_remote_path, $plugin_slug, '', $license_key );
	}
}
add_action( 'init', 'qcclr_pro_activate_au' );


function qcclr_pro_upgrade_completed( $upgrader_object, $options ) {
	// The path to our plugin's main file
	$plugin_slug = qcclr_pro_LICENSING_PLUGIN_SLUG;
	// If an update has taken place and the updated type is plugins and the plugins element exists
	if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
		// Iterate through the plugins being updated and check if ours is there
		foreach( $options['plugins'] as $plugin ) {
			if( $plugin == $plugin_slug ) {
				delete_qcclr_pro_update_transient();
				delete_qcclr_pro_renew_transient();
			}
		}
	}
}
add_action( 'upgrader_process_complete', 'qcclr_pro_upgrade_completed', 10, 2 );

add_action('admin_enqueue_scripts', 'qcclr_pro_licensing_scripts');

function qcclr_pro_licensing_scripts(){
	wp_enqueue_style('qcclr_pro_licensing_style', plugin_dir_url( __FILE__ ).'/assets/css/style.css');

	//start new-update-for-codecanyon
	wp_enqueue_script('qcclr_pro_licensing_script', plugin_dir_url( __FILE__ ).'/assets/js/script.js', array('jquery'), false, true );

	wp_localize_script( 'qcclr_pro_licensing_script', 'qcclr_pro_licensing_admin_ajax', array(
			'ajax_url' => admin_url( 'admin-ajax.php' ), 
			'nonce' => wp_create_nonce( "qcclr_pro_licensing_admin_nonce" )
		)
	);
	//end new-update-for-codecanyon
}