<?php
defined('ABSPATH') or die("No direct script access!");

function qcclr_pro_stylesheet_html() {
	$qcclr_pro_key = get_qcclr_pro_key();

	if ( $qcclr_pro_key == '' )
		return false;

	?><link rel="stylesheet" href="<?php echo plugins_url( "css.php?k={$qcclr_pro_key}&amp;t=" . mt_rand(), __FILE__ ); ?>" type="text/css" media="screen" /><?php
}

function qcclr_pro_img_html() {
	$qcclr_pro_key = get_qcclr_pro_key();

	if ( $qcclr_pro_key == '' )
		return false;

	?><img alt='css.php' src="<?php echo plugins_url( "css.php?k={$qcclr_pro_key}&amp;o=i&amp;t=" . mt_rand(), __FILE__ ); ?>" width='1' height='1' /><?php
}

if ( get_option( 'qcclr_pro_spam_protection' ) == 'enable' ) {

	if ( get_option( 'qcclr_pro_delivery' ) == 'css' ) {
		add_action( 'wp_head', 'qcclr_pro_stylesheet_html' );
	} else {
		add_action( 'wp_footer', 'qcclr_pro_img_html' );
	}

}

function get_qcclr_pro_key() {
	if( function_exists( 'get_site_option' ) ) {
		$qcclr_pro_key = get_site_option( 'qcclr_pro_key' );
	} else {
		$qcclr_pro_key = get_option( 'qcclr_pro_key' );
	}
	if( !$qcclr_pro_key ) {
		if( current_user_can('edit_plugins') ) {
			$qcclr_pro_key = md5( time() );
			if( function_exists( 'add_site_option' ) ) {
				$qcclr_pro_key = add_site_option( 'qcclr_pro_key', $qcclr_pro_key );
			} else {
				$qcclr_pro_key = add_option( 'qcclr_pro_key', $qcclr_pro_key );
			}
		} else {
			return;
		}
	}
	return $qcclr_pro_key;
}

function qcclr_pro_set_comment_style_cookie() {
	$qcclr_pro_key = get_qcclr_pro_key();
	if( !$qcclr_pro_key )
		return;

	if( strpos( $_SERVER[ 'REQUEST_URI' ], $qcclr_pro_key . '.css' ) ) {
                if ( !isset( $_COOKIE[ $qcclr_pro_key ] ) || ( isset( $_COOKIE[ $qcclr_pro_key ] ) && $_COOKIE[ $qcclr_pro_key ] == 1 ) )
                        @setcookie( $qcclr_pro_key, time(), time()+604800, '/' );
                header("Content-type: text/css");
		echo "/* Page generated by Cookies for Comments at http://ocaoimh.ie/cookies-for-comments/ */";
		define( 'DONOTCACHEPAGE', 1 ); // don't let wp-super-cache cache this page.
		die();
	}
	if( function_exists( 'akismet_auto_check_comment' ) ) {
		remove_filter( 'preprocess_comment', 'akismet_auto_check_comment', 1 );
		add_filter( 'preprocess_comment', 'akismet_auto_check_comment', 10 );
	}
}
add_action( 'init', 'qcclr_pro_set_comment_style_cookie' );

function qcclr_pro_check_comment_style_cookie( $comment ) {
	$qcclr_pro_key = get_qcclr_pro_key();
	if( !$qcclr_pro_key )
		return $comment;

	if ( is_user_logged_in() )
		return $comment;
	if ( $comment[ 'comment_type' ] != 'trackback' && $comment[ 'comment_type' ] != 'pingback' ) {
		if ( isset( $_COOKIE[ $qcclr_pro_key ] ) ) {
			$spam = 0;
			$qcclr_pro_speed = (int)get_site_option( 'qcclr_pro_speed' );
			if ( $qcclr_pro_speed > 0 && $_COOKIE[ $qcclr_pro_key ] > 1 && ( time() - $_COOKIE[ $qcclr_pro_key ] ) < $qcclr_pro_speed && !isset( $_COOKIE[ 'comment_author_' . COOKIEHASH ] ) ) {
				$spam = 1;
			}
		} else {
			$spam = 1;
		}

		if ( $spam == 1 ) {
			if( get_option( 'qcclr_pro_spam' ) == 'delete' ) {
				$msg = get_option( 'qcclr_pro_spam_message' );
				if ( !$msg ) {
					$msg = '<p>'.esc_html('Sorry, your comment has not been accepted.').'<p>';
				}
				$msg .= "<p>Your comment: <form><input type='text' value='" . esc_attr( $comment[ 'comment_author' ] ) . "' /><br /><input type='text' value='" . esc_attr( $comment[ 'comment_author_email' ] ) . "' /><br /><input type='text' value='" . esc_attr( $comment[ 'comment_author_url' ] ) . "' /><br /><textarea rows=10 cols=40>" . esc_textarea( stripslashes( $comment[ 'comment_content' ] ) ) . "</textarea></form></p>";
				wp_die( $msg );
			} else {
				// add_filter('pre_comment_approved', create_function('$a', 'return \'spam\';')); // thanks Akismet
			}
			if( function_exists( 'akismet_auto_check_comment' ) )
				remove_filter( 'preprocess_comment', 'akismet_auto_check_comment', 10 ); // remove Akismet, comment is spam!
		}
	}
	return $comment;
}
add_filter('preprocess_comment', 'qcclr_pro_check_comment_style_cookie', 1);


function qcclr_pro_conf() {
	if ( isset($_POST['submit']) ) {
		if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?'));

		check_admin_referer( 'qcclr_pro' );
		if( $_POST[ 'qcclr_pro_spam' ] == 'spam' || $_POST[ 'qcclr_pro_spam' ] == 'delete' ) {
			update_option( 'qcclr_pro_spam', $_POST[ 'qcclr_pro_spam' ] );
		}
		if( $_POST[ 'qcclr_pro_spam_protection' ] == 'enable' ) {
			update_option( 'qcclr_pro_spam_protection', $_POST[ 'qcclr_pro_spam_protection' ] );
		}else{
			update_option( 'qcclr_pro_spam_protection', '' );
		}
		update_option( 'qcclr_pro_speed', (int)$_POST[ 'qcclr_pro_speed' ] );
		update_option( 'qcclr_pro_spam_message', stripslashes( $_POST[ 'qcclr_pro_spam_message' ] ) );
		if ( $_POST[ 'qcclr_pro_delivery' ] == 'css' || $_POST[ 'qcclr_pro_delivery' ] == 'img' )
			update_option( 'qcclr_pro_delivery', $_POST[ 'qcclr_pro_delivery' ] );
	}
	if( !get_option( 'qcclr_pro_spam' ) )
		update_option( 'qcclr_pro_spam', 'spam' );
	if ( !get_option( 'qcclr_pro_delivery' ) )
		add_option( 'qcclr_pro_delivery', 'img' );

	if ( !empty($_POST ) ) { 
		?> <div id="message" class="updated fade"><p><strong><?php esc_html_e('Options saved.', 'qc-clr'); ?></strong></p></div> <?php 
	} 
	?>
<div class="wrap" >
<h2><?php _e('Comments for Cookies Configuration'); ?></h2>
<div class="narrow" style="padding:15px;">
<form action="" method="post" id="qcclr_pro_conf">
	<?php wp_nonce_field('qcclr_pro') ?>
	<h3><?php esc_html_e('Enable Spam Protection', 'qc-clr'); ?></h3> 
	<p><input type='checkbox' name='qcclr_pro_spam_protection' value='enable' <?php checked( get_option( 'qcclr_pro_spam_protection' ), 'enable' ) ?> /> <b><?php esc_html_e('Enable Spam Protection', 'qc-clr'); ?></b> </p>

	<label><h3><?php esc_html_e('What should happen to comments caught', 'qc-clr'); ?></h3> 
	<select name='qcclr_pro_spam'><option value='delete' <?php echo ( get_option( 'qcclr_pro_spam' ) == 'delete' ? 'selected' : '' ); ?> /> <?php esc_html_e('Delete', 'qc-clr'); ?> <option value='spam' <?php echo ( get_option( 'qcclr_pro_spam' ) == 'spam' ? 'selected' : '' ); ?> /> <?php esc_html_e('Spam', 'qc-clr'); ?> </select>
	</label><br />
	<h3><?php esc_html_e('Payload Delivery Mechanism', 'qc-clr'); ?></h3> 
	<input type='radio' name='qcclr_pro_delivery' value='css' <?php checked( get_option( 'qcclr_pro_delivery' ), 'css' ) ?> /> <?php esc_html_e('CSS file.', 'qc-clr'); ?><br />
	<input type='radio' name='qcclr_pro_delivery' value='img' <?php checked( get_option( 'qcclr_pro_delivery' ), 'img' ) ?> /> <?php esc_html_e('Image file. (recommended)', 'qc-clr'); ?><br />
	<p><?php esc_html_e('The CSS file loads at the top of the page, possibly slowing down how fast the page renders. The image loads at the end but if your server is very slow someone may have time to enter a comment before the image loads. Unlikely but it might happen.', 'qc-clr'); ?></p>
	<h3><?php esc_html_e('Speed Spammers', 'qc-clr'); ?></h3> 

	<p><?php esc_html_e('Some spammers visit your site, leave a real looking comment and disappear again. They\'ll do this quickly and then move on to the next target site.', 'qc-clr'); ?> <br /> <?php esc_html_e('To stop them we check how long they spend on your site before leaving the comment. Any value above 0 will reject those comments but might catch legitimate comments too. Recommended values from 3 to 6 seconds and send comments to the spam folder.', 'qc-clr'); ?> </p>
	<input type='text' name='qcclr_pro_speed' size='3' value='<?php echo (int)get_option( 'qcclr_pro_speed' ) ?>' /> <?php esc_html_e('Seconds', 'qc-clr'); ?></label><br /> <br />

	<h3><?php esc_html_e('Rejection Message', 'qc-clr'); ?></h3>
	<p><?php esc_html_e('When a comment fails to be posted it\'s not always a spammer. Add a message here to be shown to those users. Be aware that real spammers will see this message too! The comment they made will be shown below your message.', 'qc-clr'); ?></p>
	<textarea cols=40 rows=5 name='qcclr_pro_spam_message'><?php echo esc_textarea( get_option( 'qcclr_pro_spam_message' ) ); ?></textarea><br /><br />
	<input type='submit' name='submit' value='Save Options' />
	</form>
	<?php
	$qcclr_pro_key = get_qcclr_pro_key();
	if( $qcclr_pro_key ) { ?>
	<p><?php esc_html_e('If you\'re feeling adventerous, you can add the following two lines', 'qc-clr'); ?> <em> <?php esc_html_e('before', 'qc-clr'); ?></em> <?php esc_html_e('the regular WordPress mod_rewrite rules in your', 'qc-clr'); ?> <tt>.htaccess</tt> <?php esc_html_e('file. They will stop comments from spambots before they reach the database or are executed in PHP:', 'qc-clr'); ?></p>
	<pre>
	RewriteCond %{HTTP_COOKIE} !^.*<?php echo esc_attr($qcclr_pro_key); ?>.*$
	RewriteRule ^wp-comments-post.php - [F,L]
	</pre>
	<?php 
}
global $wpmu_version;
if ( isset( $wpmu_version ) && $wpmu_version != '' ) {
	?><p><?php esc_html_e('As you\'re using WordPress MU, copy these lines into your .htaccess file, making sure the paths match the location of the signup form.', 'qc-clr'); ?></p>
		<pre>
		RewriteCond %{HTTP_COOKIE} !^.*<?php echo $qcclr_pro_key; ?>.*$
		RewriteRule ^wp-signup.php - [F,L]
		</pre>
	<?php
}
?>
</div>
</div>
<?php
}


function qcclr_pro_add_referrer_to_notification( $text, $comment_id ) {
	$qcclr_pro_key = get_qcclr_pro_key();
	if( !$qcclr_pro_key )
		return $text;
	if ( is_user_logged_in() )
		return $text;

	if ( $_COOKIE[ $qcclr_pro_key ] > 1 ) {
		$ttp = ( time() - $_COOKIE[ $qcclr_pro_key ] );
		$format = "seconds";
		if ( $ttp > 60 ) {
			$ttp = $ttp / 60;
			$format = "minutes";
		}
		if ( $ttp > 60 ) {
			$ttp = $ttp / 60;
			$format = "hours";
		}


		$text .= "\r\nTime to post comment: " . number_format( $ttp, 2 ) . " $format\r\n";
	}
	return $text;
}
add_filter( 'comment_notification_text', 'qcclr_pro_add_referrer_to_notification', 10, 2 );
add_filter( 'comment_moderation_text', 'qcclr_pro_add_referrer_to_notification', 10, 2 );
?>
