<?php 

defined('ABSPATH') or die("No direct script access!");



add_action('init', 'qc_clr_email_subscription_delete');
function qc_clr_email_subscription_delete(){

    global $wpdb;
    $table             = $wpdb->prefix.'qc_clr_subscription';
    if(isset($_POST['qc_clr_email_subscription_remove']) && !empty($_POST['emails'])){
        $emails = $_POST['emails'];
        foreach($emails as $id){
        	do_action( 'qc_clr_mailing_list_unsubscription_by_admin', $id, $table );
            $wpdb->delete(
                "$table",
                array( 'id' => $id ),
                array( '%d' )
            );
        }
        wp_redirect(admin_url( 'admin.php?page=email-subscriptions&msg=success'));exit;
    }

}

add_action( 'admin_post_wpbprint.csv', 'qc_clr_export_email_csv' );
function qc_clr_export_email_csv(){
    global $wpdb;
    $table    = $wpdb->prefix.'qc_clr_subscription';
    
    if ( ! current_user_can( 'manage_options' ) )
        return;

    $emails = $wpdb->get_results("select * from $table where 1");
    $childArray = array();
    foreach($emails as $email){
        $innerArray = array();
        $innerArray[0] = $email->name;
        $innerArray[1] = $email->email;
        array_push($childArray, $innerArray);
    }
    qc_clr_download_send_headers("qc_clr_email_lists_" . date("Y-m-d") . ".csv");

    $result = qc_clr_array2csv($childArray);

    print $result;
}

function qc_clr_download_send_headers($filename) {
    // disable caching
    $now = gmdate("D, d M Y H:i:s");
    header("Expires: Tue, 03 Jul 2001 06:00:00 GMT");
    header("Cache-Control: max-age=0, no-cache, must-revalidate, proxy-revalidate");
    header("Last-Modified: {$now} GMT");

    // force download  
    header("Content-Type: application/force-download");

    // disposition / encoding on response body
    header("Content-Disposition: attachment;filename={$filename}");
    header("Content-Transfer-Encoding: binary");
}
function qc_clr_array2csv(array &$array)
{
   if (count($array) == 0) {
     return null;
   }

   ob_start();

   $df = fopen("php://output", 'w');

   $titles = array('Name', 'Email');

   fputcsv($df, $titles);

   foreach ($array as $row) {
      fputcsv($df, $row);
   }

   fclose($df);

   return ob_get_clean();
}
$clr_options = get_option( 'comment_link_remove_option_name' );
$qc_clr_email_subscription_enalbe_disable = isset($clr_options['qc_clr_email_subscription_enalbe_disable']) ? $clr_options['qc_clr_email_subscription_enalbe_disable'] : '';
if(isset($qc_clr_email_subscription_enalbe_disable) && $qc_clr_email_subscription_enalbe_disable == 1){
add_filter( 'comment_form_field_comment', 'qc_clr_comment_form_field_comment' );

}

function qc_clr_comment_form_field_comment( $comment_field ) {
    global $clr_options;
    $qc_clr_email_subscription_lang_text = $clr_options['qc_clr_email_subscription_lang_text'];

    return $comment_field.'<p><input type="checkbox" name="qcld_clr_email_subscription" value="1" class="qcld-clr-subscribe" checked> '.$qc_clr_email_subscription_lang_text.'</p>';
    
}


//save field as comment meta
add_action( 'comment_post', 'qc_clr_comment_form_save_subscription', 10, 2 );
function qc_clr_comment_form_save_subscription( $comment_id, $comment_approved  ) {

   // if( 1 === $comment_approved ){

        $qcld_clr_email_subscription = $_POST[ 'qcld_clr_email_subscription' ];

        add_comment_meta( $comment_id, 'qcld_clr_email_subscription', $qcld_clr_email_subscription );

        if($qcld_clr_email_subscription == 1){

            global $wpdb;
            $table      = $wpdb->prefix.'qc_clr_subscription';
            
            $url        = isset( $_POST['url'] ) ? esc_url_raw($_POST['url']) : '';
            $user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? sanitize_text_field($_SERVER['HTTP_USER_AGENT']) : '';

            if ( is_user_logged_in() ) {
                // your code for logged in user
                $current_user = wp_get_current_user();

                $name       = $current_user->display_name;
                $email      = $current_user->user_email;

            } else {
                $name       = isset($_POST['author'])   ? sanitize_text_field($_POST['author']) : '';
                $email      = isset($_POST['email'])    ? sanitize_email($_POST['email']) : '';
            }
            
            $email_exists = $wpdb->get_row("select * from $table where 1 and email = '".$email."'");
            if(empty($email_exists)){
            
                $wpdb->insert(
                    $table,
                    array(
                        'date'          => date('Y-m-d H:i:s'),
                        'name'          => $name,
                        'email'         => $email,
                        'url'           => $url,
                        'user_agent'    => $user_agent
                    )
                );

                do_action( 'qc_clr_mailing_list_subscription_success', $name, $email );
            
            }
            

        }

   // }


}


add_action('wp_ajax_qc_clr_email_deleted', 'qc_clr_email_deleted');
add_action('wp_ajax_nopriv_qc_clr_email_deleted', 'qc_clr_email_deleted');
function qc_clr_email_deleted(){

    $data_id = $_POST['data_id'];

    global $wpdb;
    $table             = $wpdb->prefix.'qc_clr_subscription';
    if(isset($_POST['data_id']) && !empty($_POST['data_id'])){
        $id = $_POST['data_id'];
    
        $wpdb->delete(
            "$table",
            array( 'id' => $id ),
            array( '%d' )
        );
        
    
    }

    $html = 'Email Successfully Deleted.';
    wp_send_json($html);
    wp_die();

}