<?php
defined('ABSPATH') or die("No direct script access!");
/**
 * Options Page - CLR
 */

class CommentLinkProRemove {

    private $comment_link_remove_options;

    public function __construct() {
        add_action( 'admin_menu', array( $this, 'comment_link_remove_add_plugin_page' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_9' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_10' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_8' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_6' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_2' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_3' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_4' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_7' ) );
        add_action( 'admin_init', array( $this, 'comment_link_remove_page_init_5' ) );
    }

    public function comment_link_remove_add_plugin_page() {

        add_menu_page(
            esc_html('Comment Tools Pro'), // page_title
            esc_html('Comment Tools Pro Settings'), // menu_title
            'manage_options', // capability
            'comment-link-remove', // menu_slug
            array( $this, 'comment_link_remove_create_admin_page' ), // function
            $icon_url = '',
            25
        );

    }

    public function comment_link_remove_create_admin_page() {
        
        $this->comment_link_remove_options = get_option( 'comment_link_remove_option_name' ); 
		
?>

<div class="wrap-content">
  <div id="poststuff">
    <div id="post-body" class="metabox-holder columns-2">
      <div id="post-body-content" style="position: relative;">
        <h2 class="clr_titles"><?php  esc_html_e( 'Comment Tools Pro', 'qc-clr' ); ?></h2>
        <p><?php  esc_html_e( 'Here you can manage custom settings for the Comment Link Remove plugin.', 'qc-clr' ); ?> </p>

           <?php

            global $wpdb;
            
            if( current_user_can( 'manage_options' ) )
            {
                if( isset($_POST['delAllCmts']) && $_POST['delAllCmts'] == 'delAllCmts' ){


                    if ( !isset($_POST['qc_clr_nonce']) || !wp_verify_nonce($_POST['qc_clr_nonce'],'qc-clr') ) {

                        echo "<strong>You didn't send any credentials.</strong><br>";
                        
                    }else{

                        $response = true;
                        
                        $wpdb->query($wpdb->prepare( "UPDATE `{$wpdb->prefix}posts` set comment_count=%d",0));

                        $wpdb->get_results("DELETE FROM `{$wpdb->prefix}comments` "); 

                        if($response){

                            echo "<strong>All Comments deleted successfully!</strong><br>"; 
                        }
                        
                    }
                    
                }

                if( isset($_POST['delPendingCmts']) && $_POST['delPendingCmts'] == 'delPendingCmts'  ){


                    if ( !isset($_POST['qc_clr_nonce']) || !wp_verify_nonce($_POST['qc_clr_nonce'],'qc-clr') ) {

                        echo "<strong>You didn't send any credentials.</strong><br>";
                        
                    }else{

                        $query = $wpdb->prepare( "DELETE FROM `{$wpdb->prefix}comments` WHERE `comment_approved` = %d",0);
                        $response = $wpdb->query($query);  

                        if($response){

                            echo "<strong>All Pending Comments deleted successfully!</strong><br>"; 
                        }

                    }
                    
                }

                if( isset($_POST['delSpamCmts']) && $_POST['delSpamCmts'] == 'delSpamCmts'  ){

                    if ( !isset($_POST['qc_clr_nonce']) || !wp_verify_nonce($_POST['qc_clr_nonce'],'qc-clr') ) {

                        echo "<strong>You didn't send any credentials.</strong><br>";
                        
                    }else{

                        $query = $wpdb->prepare( "DELETE FROM `{$wpdb->prefix}comments` WHERE `comment_approved` = %s",'spam');
                        $response = $wpdb->query($query);  
        

                        if($response){

                            echo "<strong>All Spam Comments deleted successfully!</strong><br>"; 
                        }

                    }
                    
                }
            }

            ?>

            <div class="clr_warapper">
                <h2><?php  esc_html_e( 'Settings', 'qc-clr' ); ?></h2>
                <div class="dele-cmts">
                  <p><strong><?php  esc_html_e( 'Delete comments easily:', 'qc-clr' ); ?> </strong></p>
                  <p></p>
                
                  <form class="qc-inline-blocks" action="" method="POST">
                    <input name="qc_clr_nonce" type="hidden" value="<?php echo wp_create_nonce('qc-clr'); ?>" />
                    <button class="commentDelete button button-primary" type="submit" name="delAllCmts" value="delAllCmts"> <?php  esc_html_e( 'Delete All Comments', 'qc-clr' ); ?> </button>
                  </form>
                  <form class="qc-inline-blocks" action="" method="POST">
                    <input name="qc_clr_nonce" type="hidden" value="<?php echo wp_create_nonce('qc-clr'); ?>" />
                    <button class="commentDelete button button-primary" type="submit" name="delPendingCmts" value="delPendingCmts"> <?php  esc_html_e( 'Delete Pending Comments', 'qc-clr' ); ?> </button>
                  </form>
                  <form class="qc-inline-blocks" action="" method="POST">
                    <input name="qc_clr_nonce" type="hidden" value="<?php echo wp_create_nonce('qc-clr'); ?>" />
                    <button class="commentDelete button button-primary" type="submit" name="delSpamCmts" value="delSpamCmts"> <?php  esc_html_e( 'Delete Spam Comments', 'qc-clr' ); ?> </button>
                  </form>
                </div>
        
        <form method="post" action="options.php">
            <?php settings_fields( 'comment_link_remove_option_group' ); ?>
            <!-- CUSTOM STYLABLE SECTION #1 -->
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'General Settings', 'qc-clr' ); ?>  </h2>
                    <?php do_settings_sections( 'comment-link-remove-admin' ,'comment_link_remove_setting_section' ); ?>

                </div>
            </div>
            <div class="clr_warapper">
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Voice Message', 'qc-clr' ); ?>  </h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-9' ,'comment_link_remove_setting_section_9' ); ?>

                </div>
            </div>
            <div class="clr_warapper">
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Comment Moderation', 'qc-clr' ); ?>  </h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-10' ,'comment_link_remove_setting_section_10' ); ?>

                </div>
            </div>
            <div class="clr_warapper">
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Email Subscription', 'qc-clr' ); ?>  </h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-8' ,'comment_link_remove_setting_section_8' ); ?>

                </div>
            </div>
            <div class="clr_warapper">

                <div class="clr_head">
                    <h2 class="qc-text-content"><?php  esc_html_e( 'Comment Sentiment Settings', 'qc-clr' ); ?>  <span style="color:red"><?php  esc_html_e( '(Works with English language only)', 'qc-clr' ); ?> </span></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-6', 'comment_link_remove_setting_section_5'); ?>
                </div>
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Set Time Interval & Message Length Requirement', 'qc-clr' ); ?></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-2', 'comment_link_remove_setting_section_1'); ?>
                </div>

                <div class="clr_head user_notification">
                    <h2><?php  esc_html_e( 'User Notification', 'qc-clr' ); ?></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-4', 'comment_link_remove_setting_section_3'); ?>
                </div>
                <div class="clr_head clr_seo_help">
                    <h2><?php  esc_html_e( 'SEO Settings', 'qc-clr' ); ?></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-3', 'comment_link_remove_setting_section_2'); ?>
                </div>
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Comment Display Settings', 'qc-clr' ); ?></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-7', 'comment_link_remove_setting_section_6'); ?>
                </div>
                <div class="clr_head">
                    <h2><?php  esc_html_e( 'Other Settings', 'qc-clr' ); ?></h2>
                    <?php do_settings_sections( 'comment-link-remove-admin-5', 'comment_link_remove_setting_section_4'); ?>
                </div>
            </div>
            <?php submit_button(); ?>
        </form>
     
        </div>
      <!-- /post-body-content -->
      
      <hr>
      
        <!-- Right Sidebar -->
        <div id="postbox-container-1" id="postbox-container">
      
          <!-- Plugin Logo -->
          <div class="qc-promo-title"><?php  esc_html_e( 'QC Comment Link Remove', 'qc-clr' ); ?></div>
      
            <!-- Promo Block 1 -->
            <div class="qc-promo-content"> 
                <div class="qc-promo-plugins">

                    <img src="<?php echo esc_url(qcclr_pro_ASSETS_URL) ?>/img/qc-logo-full.png" alt="QuantumCloud Logo">
                    <br><br><hr><br>
                    <a href="<?php echo esc_url( 'http://www.quantumcloud.com', 'qc-clr' ); ?>" target="_blank"><?php  esc_html_e( 'QuantumCloud', 'qc-clr' ); ?></a>
                </div>
            </div>
            <div class="qc-promo-plugins-info">
                <h4><?php  esc_html_e( 'Try our other free plugins!', 'qc-clr' ); ?></h4>
                <ul>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/simple-link-directory/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Simple', 'qc-clr' ); ?> <div class="qc-promo-bold">  <?php  esc_html_e( 'Link  Directory', 'qc-clr' ); ?> </div> <?php  esc_html_e( 'plugin', 'qc-clr' ); ?></a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/phone-directory/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Simple', 'qc-clr' ); ?> <div class="qc-promo-bold"> <?php  esc_html_e( 'Business Directory', 'qc-clr' ); ?> </div> <?php  esc_html_e( 'plugin with maps', 'qc-clr' ); ?></a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/simple-media-directory/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Simple', 'qc-clr' ); ?> <div class="qc-promo-bold"> <?php  esc_html_e( 'Video Directory', 'qc-clr' ); ?> </div> <?php  esc_html_e( 'plugin', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/chatbot/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'ChatBot', 'qc-clr' ); ?></div> <?php  esc_html_e( 'for WordPress', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'WPBot', 'qc-clr' ); ?></div> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/woowbot-woocommerce-chatbot/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'ChatBot', 'qc-clr' ); ?></div> <?php  esc_html_e( 'for WooCommerce', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'WoowBot', 'qc-clr' ); ?></div> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/slider-hero', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'Slider Hero', 'qc-clr' ); ?></div> <?php  esc_html_e( 'WordPress Slider Plugin', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/portfolio-x/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'WordPress', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'Portfolio', 'qc-clr' ); ?></div> <?php  esc_html_e( 'plugin', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/express-shop/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'WooCommerce', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'One Page Store', 'qc-clr' ); ?></div> <?php  esc_html_e( 'Express Shop', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/increase-sales/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'Increase Sales', 'qc-clr' ); ?></div> <?php  esc_html_e( 'on Your Stores', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/shop-assistant-for-woocommerce-jarvis/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Woocommerce', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'Shop Assistant', 'qc-clr' ); ?></div> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/woo-tabbed-category-product-listing/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Woo Tabbed Category', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'Product Listing', 'qc-clr' ); ?></div> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/ichart/', 'qc-clr' ); ?>" target="_blank"> <?php  esc_html_e( 'Easy', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'Charts', 'qc-clr' ); ?></div> <?php  esc_html_e( 'and', 'qc-clr' ); ?> <div class="qc-promo-bold"><?php  esc_html_e( 'Graphs', 'qc-clr' ); ?></div>  <?php  esc_html_e( 'plugin - iChart', 'qc-clr' ); ?></a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/infographic-and-list-builder-ilist/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'Infographic', 'qc-clr' ); ?></div> <?php  esc_html_e( 'Maker plugin - iList', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/knowledgebase-helpdesk/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'KnowledgeBase Helpdesk', 'qc-clr' ); ?></div> <?php  esc_html_e( 'Plugin with ChatBot', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/floating-action-buttons/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'Floating Action', 'qc-clr' ); ?></div> <?php  esc_html_e( 'Buttons plugin', 'qc-clr' ); ?> </a></li>
                    <li><a href="<?php echo esc_url( 'https://wordpress.org/plugins/seo-help/', 'qc-clr' ); ?>" target="_blank"> <div class="qc-promo-bold"><?php  esc_html_e( 'SEO', 'qc-clr' ); ?></div> <?php  esc_html_e( 'Help', 'qc-clr' ); ?> </a></li>
                </ul>
            </div>
        </div>
        <!-- /Right Sidebar -->
    <div class="clear"></div>
  </div>
  <div class="clear"></div>
  <!-- /post-body --> 
</div>
<!-- /poststuff -->

</div>
<?php }

    public function comment_link_remove_page_init() {
        register_setting(
            'comment_link_remove_option_group', // option_group
            'comment_link_remove_option_name', // option_name
            array( $this, 'comment_link_remove_sanitize' ) // sanitize_callback
        );

        add_settings_section(
            'comment_link_remove_setting_section', // id
            '', // title
            array( $this, 'comment_link_remove_section_info' ), // callback
            'comment-link-remove-admin' // page
        );

        add_settings_field(
            'remove_author_uri_field_0', // id
            __('Remove WEBSITE Field from Comment Form', 'qc-clr'), // title
            array( $this, 'remove_author_uri_field_0_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'remove_any_link_from_author_field_1', // id
            __('Remove hyper-link from comment AUTHOR Bio', 'qc-clr'), // title
            array( $this, 'remove_any_link_from_author_field_1_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'remove_links_from_comments_field_3', // id
            __('Disable turning URLs into hyper-links in comments', 'qc-clr'), // title
            array( $this, 'remove_links_from_comments_field_3_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'remove_links_from_comments_field_2', // id
            __('Remove HTML Link Tags in comments', 'qc-clr'), // title
            array( $this, 'remove_links_from_comments_field_2_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'disable_comments_totally', // id
            __('Disable Comments Globally', 'qc-clr'), // title
            array( $this, 'disable_comments_totally_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'hide_existing_cmts', // id
            __('Hide Existing Comments', 'qc-clr'), // title
            array( $this, 'hide_existing_cmts_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );

        add_settings_field(
            'open_link_innewtab', // id
            __('Open Comment Links in New Tab', 'qc-clr'), // title
            array( $this, 'open_link_innewtab_callback' ), // callback
            'comment-link-remove-admin', // page
            'comment_link_remove_setting_section' // section
        );


    }


    public function comment_link_remove_page_init_2() {
        add_settings_section(
            'comment_link_remove_setting_section_1', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_2' ), // callback
            'comment-link-remove-admin-2' // page
        );

        add_settings_field(
            'comment_time_minimum', // id
            __('Minimum Time (In Seconds) <br> <span class="qcld_msg">( Set Time Interval Required Between Comments to Avoid Spamming )</span>', 'qc-clr'), // title
            array( $this, 'comment_time_minimum_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

        add_settings_field(
            'comment_quick_mgs', // id
            __('Custom Message for Quick comments', 'qc-clr'), // title
            array( $this, 'comment_quick_mgs_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

        add_settings_field(
            'comment_minimum_length', // id
            __('Minimum Length of Character in Comments <br> <span class="qcld_msg">( Avoid Low Value Comments )</span>', 'qc-clr'), // title
            array( $this, 'comment_minimum_length_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

        add_settings_field(
            'comment_minimum_length_mgs', // id
            __('Alert Message for Minimum Comments Length ', 'qc-clr'), // title
            array( $this, 'comment_minimum_length_mgs_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

        add_settings_field(
            'comment_maximum_length', // id
            __('Maximum of Character in Comments <br> <span class="qcld_msg">( Helps Avoid Spamming )</span>', 'qc-clr'), // title
            array( $this, 'comment_maximum_length_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

        add_settings_field(
            'comment_maximum_length_mgs', // id
            __('Alert Message for Maximum Comments Length ', 'qc-clr'), // title
            array( $this, 'comment_maximum_length_mgs_callback' ), // callback
            'comment-link-remove-admin-2', // page
            'comment_link_remove_setting_section_1' // section
        );

    }


    public function comment_link_remove_page_init_3() {
        add_settings_section(
            'comment_link_remove_setting_section_2', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_3' ), // callback
            'comment-link-remove-admin-3' // page
        );

        add_settings_field(
            'comment_link_follow', // id
            __('Set “follow” or “nofollow” to Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_follow_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_ugc', // id
            __('Add “ugc” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_ugc_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_noreffer', // id
            __('Add “noreferrer” to “rel” attribute if  Comments Link Open in New Tab  ', 'qc-clr'), // title
            array( $this, 'comment_link_noreffer_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_noopener', // id
            __('Add “noopener” to “rel” attribute if  Comments Link Open in New Tab  ', 'qc-clr'), // title
            array( $this, 'comment_link_noopener_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post', // id
            __('Enable nofollow sponsored and ugc in the contents', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_content', // id
            __('Enable for Blog Posts', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_content_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_page_content', // id
            __('Enable for Pages', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_page_content_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_follow', // id
            __('Set “follow” or “nofollow” to Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_follow_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_ugc', // id
            __('Add “ugc” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_ugc_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_noreffer', // id
            __('Add “noreferrer” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_noreffer_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_noopener', // id
            __('Add “noopener” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_noopener_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_author', // id
            __('Enable nofollow sponsored and ugc in the Author Link', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_author_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_follow_author', // id
            __('Set “follow” or “nofollow” to Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_follow_author_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_ugc_author', // id
            __('Add “ugc” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_ugc_author_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_noreffer_author', // id
            __('Add “noreferrer” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_noreffer_author_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );

        add_settings_field(
            'comment_link_blog_post_author_noopener', // id
            __('Add “noopener” to “rel” attribute if  Comments Link ', 'qc-clr'), // title
            array( $this, 'comment_link_blog_post_noopener_author_callback' ), // callback
            'comment-link-remove-admin-3', // page
            'comment_link_remove_setting_section_2' // section
        );


    }


    public function comment_link_remove_page_init_4() {
        add_settings_section(
            'comment_link_remove_setting_section_3', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_4' ), // callback
            'comment-link-remove-admin-4' // page
        );

        add_settings_field(
            'comment_notify_user_comment_approved', // id
            __('Notify a user when their comment is approved', 'qc-clr'), // title
            array( $this, 'comment_notify_user_comment_approved_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );
        add_settings_field(
            'notify_user_comment_subject', // id
            __('Notification Subject', 'qc-clr'), // title
            array( $this, 'notify_user_comment_subject_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_user_comment_messsage', // id
            __('Notification Message ', 'qc-clr'), // title
            array( $this, 'notify_user_comment_messsage_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_all_commenter_messsage', // id
            __('Notify All Commenters of the Post when There is a New Comment', 'qc-clr'), // title
            array( $this, 'notify_all_commenter_messsage_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_all_commenter_messsage_subject', // id
            __('Notification Subject ', 'qc-clr'), // title
            array( $this, 'notify_all_commenter_messsage_subject_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_all_user_commenter_messsage', // id
            __('Notify All Users of the site when There is a New Comment on Any Post', 'qc-clr'), // title
            array( $this, 'notify_all_user_commenter_messsage_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_all_users_messsage_subject', // id
            __('Notification Subject ', 'qc-clr'), // title
            array( $this, 'notify_all_users_messsage_subject_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_only_user_commenter_messsage', // id
            __('Notify User only if someone replies to his own comment', 'qc-clr'), // title
            array( $this, 'notify_only_user_commenter_messsage_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );

        add_settings_field(
            'notify_only_user_messsage_subject', // id
            __('Notification Subject ', 'qc-clr'), // title
            array( $this, 'notify_only_user_messsage_subject_callback' ), // callback
            'comment-link-remove-admin-4', // page
            'comment_link_remove_setting_section_3' // section
        );



    }


    public function comment_link_remove_page_init_5() {
        add_settings_section(
            'comment_link_remove_setting_section_4', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_5' ), // callback
            'comment-link-remove-admin-5' // page
        );

        add_settings_field(
            'comment_redirect', // id
            __('Redirect Page after Comments', 'qc-clr'), // title
            array( $this, 'comment_redirect_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );


        add_settings_field(
            'comment_admin_section_email_individual_comenters', // id
            __('Links in the admin comments section to email individual commenters', 'qc-clr'), // title
            array( $this, 'comment_admin_section_email_individual_comenters_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        add_settings_field(
            'comment_button_wp_toolbar_email_commenters_post', // id
            __('Enable a button in the WP toolbar to email all the commenters on a post', 'qc-clr'), // title
            array( $this, 'comment_button_wp_toolbar_email_commenters_post_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        add_settings_field(
            'comment_show_all_comments', // id
            __('Show All Comments', 'qc-clr'), // title
            array( $this, 'comment_show_all_comments_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );


        add_settings_field(
            'comment_show_private_comments', // id
            __('Enable Private Comment', 'qc-clr'), // title
            array( $this, 'comment_show_private_comments_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );


        add_settings_field(
            'comment_collapse_replies_comments', // id
            __('Collapse comment replies', 'qc-clr'), // title
            array( $this, 'comment_collapse_replies_comments_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        add_settings_field(
            'comment_collapse_replies_lang_comment', // id
            __('Comment', 'qc-clr'), // title
            array( $this, 'comment_collapse_replies_lang_comment_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        add_settings_field(
            'comment_collapse_replies_lang_comments', // id
            __('Comments', 'qc-clr'), // title
            array( $this, 'comment_collapse_replies_lang_comments_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        add_settings_field(
            'comment_collapse_replies_lang_back', // id
            __('Back', 'qc-clr'), // title
            array( $this, 'comment_collapse_replies_lang_back_callback' ), // callback
            'comment-link-remove-admin-5', // page
            'comment_link_remove_setting_section_4' // section
        );

        

    }


    public function comment_link_remove_page_init_7() {
        add_settings_section(
            'comment_link_remove_setting_section_6', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_7' ), // callback
            'comment-link-remove-admin-7' // page
        );


        add_settings_field(
            'show_hide_all_comment', // id
            __('Show/Hide all comments', 'qc-clr'), // title
            array( $this, 'show_hide_all_comment_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'show_hide_all_comment_lang_text', // id
            __('Show All Comments', 'qc-clr'), // title
            array( $this, 'show_hide_all_comment_lang_text_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'show_hide_all_comment_lang_text_hide', // id
            __('Hide All Comments', 'qc-clr'), // title
            array( $this, 'show_hide_all_comment_lang_text_hide_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'show_hide_all_comment_lang_text_write_a_response', // id
            __('Write a Response', 'qc-clr'), // title
            array( $this, 'show_hide_all_comment_lang_text_write_a_response_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'show_hide_all_comment_lang_text_hide_response', // id
            __('Hide Response', 'qc-clr'), // title
            array( $this, 'show_hide_all_comment_lang_text_hide_response_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'qcld_quick_comment_button', // id
            __('Quick Comment button', 'qc-clr'), // title
            array( $this, 'qcld_quick_comment_button_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );


        add_settings_field(
            'comment_readmore', // id
            __('Enable Comments Read More option', 'qc-clr'), // title
            array( $this, 'comment_readmore_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'comment_readmore_length', // id
            __('Show Read More after (in Words)', 'qc-clr'), // title
            array( $this, 'comment_readmore_length_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'comment_add_sidebar_widget_show_top_commentators', // id
            __('Add a sidebar widget to show the top commentators', 'qc-clr'), // title
            array( $this, 'comment_add_sidebar_widget_show_top_commentators_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'comment_sidebar_widget_show_top_comment_post_page_only', // id
            __('Show the top commentators widget only Post Page', 'qc-clr'), // title
            array( $this, 'comment_sidebar_widget_show_top_comment_post_page_only_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'comment_vertical_scroll_recent_widget_comments', // id
            __('Vertical scroll in recent comments widget', 'qc-clr'), // title
            array( $this, 'comment_vertical_scroll_recent_widget_comments_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

        add_settings_field(
            'comment_pin_commenter_comments', // id
            __('Pin a Comment to Show Comment On Top Position', 'qc-clr'), // title
            array( $this, 'comment_pin_commenter_comments_callback' ), // callback
            'comment-link-remove-admin-7', // page
            'comment_link_remove_setting_section_6' // section
        );

    }


    public function comment_link_remove_page_init_6() {
        add_settings_section(
            'comment_link_remove_setting_section_5', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_6' ), // callback
            'comment-link-remove-admin-6' // page
        );

       add_settings_field(
            'like_dislike', // id
            __('Enable Like/Dislike', 'qc-clr'), // title
            array( $this, 'like_dislike' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        add_settings_field(
            'enable_comment_like_dislike_filter', // id
            __('Allow Comments Filtering by Like/Dislike (Fontend)', 'qc-clr'), // title
            array( $this, 'enable_comment_like_dislike_filter' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        add_settings_field(
            'enable_emotions', // id
            __('Show Emotions in Comment', 'qc-clr'), // title
            array( $this, 'enable_emotions' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        add_settings_field(
            'enable_comment_filter', // id
            __('Allow Comments Filtering by Sentiment (Fontend)', 'qc-clr'), // title
            array( $this, 'enable_comment_filter' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'enable_comment_threshold', // id
            __('Allow Comments Threshold by Negative Score', 'qc-clr'), // title
            array( $this, 'enable_comment_threshold' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'treshold_score', // id
            __('Threshold by Negative Score (EX: 0.5)', 'qc-clr'), // title
            array( $this, 'treshold_score' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'treshold_msg', // id
            __('Threshold Message', 'qc-clr'), // title
            array( $this, 'treshold_msg' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_filter_comments', // id
            __('Filter Comments by Sentiment', 'qc-clr'), // title
            array( $this, 'comment_lang_text_filter_comments_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_filter_like_dislike_comments', // id
            __('Filter Comments by Like/Dislike', 'qc-clr'), // title
            array( $this, 'comment_lang_text_filter_like_dislike_comments_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_all_comments', // id
            __('All Comments', 'qc-clr'), // title
            array( $this, 'comment_lang_text_all_comments_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_positive', // id
            __('Positive', 'qc-clr'), // title
            array( $this, 'comment_lang_text_positive_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_negative', // id
            __('Negative', 'qc-clr'), // title
            array( $this, 'comment_lang_text_negative_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );
        
        add_settings_field(
            'comment_lang_text_neutral', // id
            __('Neutral', 'qc-clr'), // title
            array( $this, 'comment_lang_text_neutral_callback' ), // callback
            'comment-link-remove-admin-6', // page
            'comment_link_remove_setting_section_5' // section
        );

    }


    public function comment_link_remove_page_init_8() {
        add_settings_section(
            'comment_link_remove_setting_section_8', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_8' ), // callback
            'comment-link-remove-admin-8' // page
        );

       add_settings_field(
            'qc_clr_email_subscription_enalbe_disable', // id
            __('Enable Email Subscription', 'qc-clr'), // title
            array( $this, 'qc_clr_email_subscription_enalbe_disable_callback' ), // callback
            'comment-link-remove-admin-8', // page
            'comment_link_remove_setting_section_8' // section
        ); 

       add_settings_field(
            'qc_clr_email_subscription_lang_text', // id
            __('Language ( Subscribe to our newsletter ) ', 'qc-clr'), // title
            array( $this, 'qc_clr_email_subscription_lang_text_callback' ), // callback
            'comment-link-remove-admin-8', // page
            'comment_link_remove_setting_section_8' // section
        );
        add_settings_field(
            'qc_clr_email_subscription_mailchamp_enalbe_disable', // id
            __('Enable Mailchamp :', 'qc-clr'), // title
            array( $this, 'qc_clr_email_subscription_mailchamp_enalbe_disable_callback' ), // callback
            'comment-link-remove-admin-8', // page
            'comment_link_remove_setting_section_8' // section
        );
        add_settings_field(
            'qc_clr_email_subscription_zapier_enalbe_disable', // id
            __('Enable Zapier', 'qc-clr'), // title
            array( $this, 'qc_clr_email_subscription_zapier_enalbe_disable_callback' ), // callback
            'comment-link-remove-admin-8', // page
            'comment_link_remove_setting_section_8' // section
        );
       

    }


    public function comment_link_remove_page_init_9() {
        add_settings_section(
            'comment_link_remove_setting_section_9', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_9' ), // callback
            'comment-link-remove-admin-9' // page
        );

       add_settings_field(
            'comment_show_voice_message_enable', // id
            __('Enable Voice Message on User Comments', 'qc-clr'), // title
            array( $this, 'comment_show_voice_message_comments_callback' ), // callback
            'comment-link-remove-admin-9', // page
            'comment_link_remove_setting_section_9' // section
        );

        if ( class_exists('WooCommerce') ) {

            add_settings_field(
                'comment_show_voice_message_enable_for_woocommerce', // id
                __('Enable Voice Message on woocommerce', 'qc-clr'), // title
                array( $this, 'comment_show_voice_message_enable_for_woocommerce_callback' ), // callback
                'comment-link-remove-admin-9', // page
                'comment_link_remove_setting_section_9' // section
            );

       }
       

    }


    public function comment_link_remove_page_init_10() {
        add_settings_section(
            'comment_link_remove_setting_section_10', // id
            '', // title
            array( $this, 'comment_link_remove_section_info_10' ), // callback
            'comment-link-remove-admin-10' // page
        );

        add_settings_field(
            'comment_button_delete_commenters_comment', // id
            __('Enable Delete and Move To Spam Buttons on the Frontend', 'qc-clr'), // title
            array( $this, 'comment_button_delete_commenters_comment_callback' ), // callback
            'comment-link-remove-admin-10', // page
            'comment_link_remove_setting_section_10' // section
        );

        add_settings_field(
            'comment_exclude_text_comments', // id
            __('Auto Moderate Comments by Keywords or Phrase', 'qc-clr'), // title
            array( $this, 'comment_exclude_comments_callback' ), // callback
            'comment-link-remove-admin-10', // page
            'comment_link_remove_setting_section_10' // section
        );

        add_settings_field(
            'comment_exclude_action', // id
            __('Auto Moderate Comments Action', 'qc-clr'), // title
            array( $this, 'comment_exclude_action_callback' ), // callback
            'comment-link-remove-admin-10', // page
            'comment_link_remove_setting_section_10' // section
        );
       

    }

    public function comment_link_remove_sanitize($input) {
        $sanitary_values = array();
        if ( isset( $input['remove_author_uri_field_0'] ) ) {
            $sanitary_values['remove_author_uri_field_0'] = $input['remove_author_uri_field_0'];
        }

        if ( isset( $input['remove_any_link_from_author_field_1'] ) ) {
            $sanitary_values['remove_any_link_from_author_field_1'] = $input['remove_any_link_from_author_field_1'];
        }

        if ( isset( $input['remove_links_from_comments_field_3'] ) ) {
            $sanitary_values['remove_links_from_comments_field_3'] = $input['remove_links_from_comments_field_3'];
        }

        if ( isset( $input['remove_links_from_comments_field_2'] ) ) {
            $sanitary_values['remove_links_from_comments_field_2'] = $input['remove_links_from_comments_field_2'];
        }

        if ( isset( $input['disable_comments_totally'] ) ) {
            $sanitary_values['disable_comments_totally'] = $input['disable_comments_totally'];
        }

        if ( isset( $input['hide_existing_cmts'] ) ) {
            $sanitary_values['hide_existing_cmts'] = $input['hide_existing_cmts'];
        }

        if ( isset( $input['open_link_innewtab'] ) ) {
            $sanitary_values['open_link_innewtab'] = $input['open_link_innewtab'];
        }
		if ( isset( $input['like_dislike'] ) ) {
            $sanitary_values['like_dislike'] = $input['like_dislike'];
        }
        if ( isset( $input['enable_comment_like_dislike_filter'] ) ) {
            $sanitary_values['enable_comment_like_dislike_filter'] = $input['enable_comment_like_dislike_filter'];
        }
		if ( isset( $input['enable_emotions'] ) ) {
            $sanitary_values['enable_emotions'] = $input['enable_emotions'];
        }
		if ( isset( $input['enable_comment_filter'] ) ) {
            $sanitary_values['enable_comment_filter'] = $input['enable_comment_filter'];
        }
		if ( isset( $input['enable_comment_threshold'] ) ) {
            $sanitary_values['enable_comment_threshold'] = $input['enable_comment_threshold'];
        }
		if ( isset( $input['treshold_score'] ) ) {
            $sanitary_values['treshold_score'] = $input['treshold_score'];
        }
		if ( isset( $input['treshold_msg'] ) ) {
            $sanitary_values['treshold_msg'] = $input['treshold_msg'];
        }
        
        if ( isset( $input['comment_time_minimum'] ) ) {
            $sanitary_values['comment_time_minimum'] = $input['comment_time_minimum'];
        }

        if ( isset( $input['comment_quick_mgs'] ) ) {
            $sanitary_values['comment_quick_mgs'] = $input['comment_quick_mgs'];
        }

        if ( isset( $input['comment_minimum_length'] ) ) {
            $sanitary_values['comment_minimum_length'] = $input['comment_minimum_length'];
        }

        if ( isset( $input['comment_minimum_length_mgs'] ) ) {
            $sanitary_values['comment_minimum_length_mgs'] = $input['comment_minimum_length_mgs'];
        }

        if ( isset( $input['comment_maximum_length'] ) ) {
            $sanitary_values['comment_maximum_length'] = $input['comment_maximum_length'];
        }

        if ( isset( $input['comment_maximum_length_mgs'] ) ) {
            $sanitary_values['comment_maximum_length_mgs'] = $input['comment_maximum_length_mgs'];
        }
        if ( isset( $input['comment_redirect'] ) ) {
            $sanitary_values['comment_redirect'] = $input['comment_redirect'];
        }

        if ( isset( $input['comment_readmore'] ) ) {
            $sanitary_values['comment_readmore'] = $input['comment_readmore'];
        }

        if ( isset( $input['show_hide_all_comment'] ) ) {
            $sanitary_values['show_hide_all_comment'] = $input['show_hide_all_comment'];
        }

        if ( isset( $input['qcld_quick_comment_button'] ) ) {
            $sanitary_values['qcld_quick_comment_button'] = $input['qcld_quick_comment_button'];
        }

        if ( isset( $input['show_hide_all_comment_lang_text'] ) ) {
            $sanitary_values['show_hide_all_comment_lang_text'] = $input['show_hide_all_comment_lang_text'];
        }

        if ( isset( $input['show_hide_all_comment_lang_text_hide'] ) ) {
            $sanitary_values['show_hide_all_comment_lang_text_hide'] = $input['show_hide_all_comment_lang_text_hide'];
        }

        if ( isset( $input['show_hide_all_comment_lang_text_write_a_response'] ) ) {
            $sanitary_values['show_hide_all_comment_lang_text_write_a_response'] = $input['show_hide_all_comment_lang_text_write_a_response'];
        }

        if ( isset( $input['show_hide_all_comment_lang_text_hide_response'] ) ) {
            $sanitary_values['show_hide_all_comment_lang_text_hide_response'] = $input['show_hide_all_comment_lang_text_hide_response'];
        }

        if ( isset( $input['comment_collapse_replies_lang_comment'] ) ) {
            $sanitary_values['comment_collapse_replies_lang_comment'] = $input['comment_collapse_replies_lang_comment'];
        }

        if ( isset( $input['comment_collapse_replies_lang_comments'] ) ) {
            $sanitary_values['comment_collapse_replies_lang_comments'] = $input['comment_collapse_replies_lang_comments'];
        }

        if ( isset( $input['comment_collapse_replies_lang_back'] ) ) {
            $sanitary_values['comment_collapse_replies_lang_back'] = $input['comment_collapse_replies_lang_back'];
        }

        if ( isset( $input['comment_readmore_length'] ) ) {
            $sanitary_values['comment_readmore_length'] = $input['comment_readmore_length'];
        }

        if ( isset( $input['comment_link_follow'] ) ) {
            $sanitary_values['comment_link_follow'] = $input['comment_link_follow'];
        }

        if ( isset( $input['comment_link_ugc'] ) ) {
            $sanitary_values['comment_link_ugc'] = $input['comment_link_ugc'];
        }

        if ( isset( $input['comment_lang_text_filter_comments'] ) ) {
            $sanitary_values['comment_lang_text_filter_comments'] = $input['comment_lang_text_filter_comments'];
        }

        if ( isset( $input['comment_lang_text_filter_like_dislike_comments'] ) ) {
            $sanitary_values['comment_lang_text_filter_like_dislike_comments'] = $input['comment_lang_text_filter_like_dislike_comments'];
        }

        if ( isset( $input['comment_lang_text_all_comments'] ) ) {
            $sanitary_values['comment_lang_text_all_comments'] = $input['comment_lang_text_all_comments'];
        }

        if ( isset( $input['comment_lang_text_positive'] ) ) {
            $sanitary_values['comment_lang_text_positive'] = $input['comment_lang_text_positive'];
        }

        if ( isset( $input['comment_lang_text_negative'] ) ) {
            $sanitary_values['comment_lang_text_negative'] = $input['comment_lang_text_negative'];
        }

        if ( isset( $input['comment_lang_text_neutral'] ) ) {
            $sanitary_values['comment_lang_text_neutral'] = $input['comment_lang_text_neutral'];
        }

        if ( isset( $input['comment_link_noreffer'] ) ) {
            $sanitary_values['comment_link_noreffer'] = $input['comment_link_noreffer'];
        }

        if ( isset( $input['comment_link_noopener'] ) ) {
            $sanitary_values['comment_link_noopener'] = $input['comment_link_noopener'];
        }

        if ( isset( $input['comment_link_blog_post'] ) ) {
            $sanitary_values['comment_link_blog_post'] = $input['comment_link_blog_post'];
        }

        if ( isset( $input['comment_link_blog_post_content'] ) ) {
            $sanitary_values['comment_link_blog_post_content'] = $input['comment_link_blog_post_content'];
        }

        if ( isset( $input['comment_link_blog_post_page_content'] ) ) {
            $sanitary_values['comment_link_blog_post_page_content'] = $input['comment_link_blog_post_page_content'];
        }

        if ( isset( $input['comment_link_blog_post_follow'] ) ) {
            $sanitary_values['comment_link_blog_post_follow'] = $input['comment_link_blog_post_follow'];
        }

        if ( isset( $input['comment_link_blog_post_ugc'] ) ) {
            $sanitary_values['comment_link_blog_post_ugc'] = $input['comment_link_blog_post_ugc'];
        }

        if ( isset( $input['comment_link_blog_post_noreffer'] ) ) {
            $sanitary_values['comment_link_blog_post_noreffer'] = $input['comment_link_blog_post_noreffer'];
        }

        if ( isset( $input['comment_link_blog_post_noopener'] ) ) {
            $sanitary_values['comment_link_blog_post_noopener'] = $input['comment_link_blog_post_noopener'];
        }

        if ( isset( $input['comment_link_blog_post_author'] ) ) {
            $sanitary_values['comment_link_blog_post_author'] = $input['comment_link_blog_post_author'];
        }

        if ( isset( $input['comment_link_blog_post_follow_author'] ) ) {
            $sanitary_values['comment_link_blog_post_follow_author'] = $input['comment_link_blog_post_follow_author'];
        }

        if ( isset( $input['comment_link_blog_post_ugc_author'] ) ) {
            $sanitary_values['comment_link_blog_post_ugc_author'] = $input['comment_link_blog_post_ugc_author'];
        }

        if ( isset( $input['comment_link_blog_post_noreffer_author'] ) ) {
            $sanitary_values['comment_link_blog_post_noreffer_author'] = $input['comment_link_blog_post_noreffer_author'];
        }

        if ( isset( $input['comment_link_blog_post_author_noopener'] ) ) {
            $sanitary_values['comment_link_blog_post_author_noopener'] = $input['comment_link_blog_post_author_noopener'];
        }

        // admin section email individual commenters ...
        if ( isset( $input['comment_admin_section_email_individual_comenters'] ) ) {
            $sanitary_values['comment_admin_section_email_individual_comenters'] = $input['comment_admin_section_email_individual_comenters'];
        }
        // A button in the WP toolbar to email all the commenters on a post ...
        if ( isset( $input['comment_button_wp_toolbar_email_commenters_post'] ) ) {
            $sanitary_values['comment_button_wp_toolbar_email_commenters_post'] = $input['comment_button_wp_toolbar_email_commenters_post'];
        }
        // A button comment_button_delete_commenters_comment ...
        if ( isset( $input['comment_button_delete_commenters_comment'] ) ) {
            $sanitary_values['comment_button_delete_commenters_comment'] = $input['comment_button_delete_commenters_comment'];
        }
        // A button comment_exclude_text_comments ...
        if ( isset( $input['comment_exclude_text_comments'] ) ) {
            $sanitary_values['comment_exclude_text_comments'] = $input['comment_exclude_text_comments'];
        }
        // A button comment_exclude_action ...
        if ( isset( $input['comment_exclude_action'] ) ) {
            $sanitary_values['comment_exclude_action'] = $input['comment_exclude_action'];
        }
        // Notify a user when their comment is approved ...
        if ( isset( $input['comment_notify_user_comment_approved'] ) ) {
            $sanitary_values['comment_notify_user_comment_approved'] = $input['comment_notify_user_comment_approved'];
        }
        // Notify a user when their comment is approved mail Subject ... 
        if ( isset( $input['notify_user_comment_subject'] ) ) {
            $sanitary_values['notify_user_comment_subject'] = $input['notify_user_comment_subject'];
        }
        // Notify a user when their comment is approved mail Message ...
        if ( isset( $input['notify_user_comment_messsage'] ) ) {
            $sanitary_values['notify_user_comment_messsage'] = $input['notify_user_comment_messsage'];
        }
        // Notify all commenters when anyone post new comment ...
        if ( isset( $input['notify_all_commenter_messsage'] ) ) {
            $sanitary_values['notify_all_commenter_messsage'] = $input['notify_all_commenter_messsage'];
        }
        // Notify all commenters Subject ...
        if ( isset( $input['notify_all_commenter_messsage_subject'] ) ) {
            $sanitary_values['notify_all_commenter_messsage_subject'] = $input['notify_all_commenter_messsage_subject'];
        }
        // Notify all users Subject ...
        if ( isset( $input['notify_all_users_messsage_subject'] ) ) {
            $sanitary_values['notify_all_users_messsage_subject'] = $input['notify_all_users_messsage_subject'];
        }
        // Notify all users Subject ...
        if ( isset( $input['notify_only_user_commenter_messsage'] ) ) {
            $sanitary_values['notify_only_user_commenter_messsage'] = $input['notify_only_user_commenter_messsage'];
        }
        // Notify all users Subject ...
        if ( isset( $input['notify_only_user_messsage_subject'] ) ) {
            $sanitary_values['notify_only_user_messsage_subject'] = $input['notify_only_user_messsage_subject'];
        }
        // Notify all User when anyone post new comment ...
        if ( isset( $input['notify_all_user_commenter_messsage'] ) ) {
            $sanitary_values['notify_all_user_commenter_messsage'] = $input['notify_all_user_commenter_messsage'];
        }
        // add_sidebar_widget_show_top_commentators ...
        if ( isset( $input['comment_add_sidebar_widget_show_top_commentators'] ) ) {
            $sanitary_values['comment_add_sidebar_widget_show_top_commentators'] = $input['comment_add_sidebar_widget_show_top_commentators'];
        }
        // add_sidebar_widget_show_top_commentators ...
        if ( isset( $input['comment_sidebar_widget_show_top_comment_post_page_only'] ) ) {
            $sanitary_values['comment_sidebar_widget_show_top_comment_post_page_only'] = $input['comment_sidebar_widget_show_top_comment_post_page_only'];
        }
        // Show All Comments ...
        if ( isset( $input['comment_show_all_comments'] ) ) {
            $sanitary_values['comment_show_all_comments'] = $input['comment_show_all_comments'];
        }
        if ( isset( $input['comment_show_private_comments'] ) ) {
            $sanitary_values['comment_show_private_comments'] = $input['comment_show_private_comments'];
        }
        if ( isset( $input['comment_collapse_replies_comments'] ) ) {
            $sanitary_values['comment_collapse_replies_comments'] = $input['comment_collapse_replies_comments'];
        }
        if ( isset( $input['comment_show_voice_message_enable'] ) ) {
            $sanitary_values['comment_show_voice_message_enable'] = $input['comment_show_voice_message_enable'];
        }
        if ( isset( $input['comment_show_voice_message_enable_for_woocommerce'] ) ) {
            $sanitary_values['comment_show_voice_message_enable_for_woocommerce'] = $input['comment_show_voice_message_enable_for_woocommerce'];
        }
        // Vertical scroll recent comments widget ... 204539
        if ( isset( $input['comment_vertical_scroll_recent_widget_comments'] ) ) {
            $sanitary_values['comment_vertical_scroll_recent_widget_comments'] = $input['comment_vertical_scroll_recent_widget_comments'];
        }

        if ( isset( $input['comment_pin_commenter_comments'] ) ) {
            $sanitary_values['comment_pin_commenter_comments'] = $input['comment_pin_commenter_comments'];
        }

        // Allows to export the names and email addresses of users ...
        if ( isset( $input['comment_allows_export_the_names_and_email_addresses_comments'] ) ) {
            $sanitary_values['comment_allows_export_the_names_and_email_addresses_comments'] = $input['comment_allows_export_the_names_and_email_addresses_comments'];
        }
        
        // Allows qc_clr_email_subscription_enalbe_disable ...
        if ( isset( $input['qc_clr_email_subscription_enalbe_disable'] ) ) {
            $sanitary_values['qc_clr_email_subscription_enalbe_disable'] = $input['qc_clr_email_subscription_enalbe_disable'];
        }

        // Allows qc_clr_email_subscription_lang_text ...
        if ( isset( $input['qc_clr_email_subscription_lang_text'] ) ) {
            $sanitary_values['qc_clr_email_subscription_lang_text'] = $input['qc_clr_email_subscription_lang_text'];
        }

        // qc_clr_email_subscription_mailchamp_enalbe_disable ...
        if ( isset( $input['qc_clr_email_subscription_mailchamp_enalbe_disable'] ) ) {
            $sanitary_values['qc_clr_email_subscription_mailchamp_enalbe_disable'] = $input['qc_clr_email_subscription_mailchamp_enalbe_disable'];
        }

        // qc_clr_email_subscription_zapier_enalbe_disable ...
        if ( isset( $input['qc_clr_email_subscription_zapier_enalbe_disable'] ) ) {
            $sanitary_values['qc_clr_email_subscription_zapier_enalbe_disable'] = $input['qc_clr_email_subscription_zapier_enalbe_disable'];
        }

        return $sanitary_values;
    }

    public function comment_link_remove_section_info() {
        
    }

    public function comment_link_remove_section_info_2() {
        
    }

    public function comment_link_remove_section_info_3() {
        
    }

    public function comment_link_remove_section_info_4() {
        
    }

    public function comment_link_remove_section_info_5() {
        
    }

    public function comment_link_remove_section_info_6() {
        
    }

    public function comment_link_remove_section_info_7() {
        
    }

    public function comment_link_remove_section_info_8() {
        
    }

    public function comment_link_remove_section_info_9() {
        
    }

    public function comment_link_remove_section_info_10() {
        
    }


    public function remove_author_uri_field_0_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[remove_author_uri_field_0]" id="remove_author_uri_field_0" value="1" %s>',
            ( isset( $this->comment_link_remove_options['remove_author_uri_field_0'] ) && $this->comment_link_remove_options['remove_author_uri_field_0'] === '1' ) ? 'checked' : ''
        );
    }

    public function remove_any_link_from_author_field_1_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[remove_any_link_from_author_field_1]" id="remove_any_link_from_author_field_1" value="1" %s>',
            ( isset( $this->comment_link_remove_options['remove_any_link_from_author_field_1'] ) && $this->comment_link_remove_options['remove_any_link_from_author_field_1'] === '1' ) ? 'checked' : ''
        );
    }

    public function remove_links_from_comments_field_3_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[remove_links_from_comments_field_3]" id="remove_links_from_comments_field_3" value="1" %s>',
            ( isset( $this->comment_link_remove_options['remove_links_from_comments_field_3'] ) && $this->comment_link_remove_options['remove_links_from_comments_field_3'] === '1' ) ? 'checked' : ''
        );
    }

    public function remove_links_from_comments_field_2_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[remove_links_from_comments_field_2]" id="remove_links_from_comments_field_2" value="1" %s>',
            ( isset( $this->comment_link_remove_options['remove_links_from_comments_field_2'] ) && $this->comment_link_remove_options['remove_links_from_comments_field_2'] === '1' ) ? 'checked' : ''
        );
    }

    public function disable_comments_totally_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[disable_comments_totally]" id="disable_comments_totally" value="1" %s>',
            ( isset( $this->comment_link_remove_options['disable_comments_totally'] ) && $this->comment_link_remove_options['disable_comments_totally'] === '1' ) ? 'checked' : ''
        );
    }

    public function hide_existing_cmts_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[hide_existing_cmts]" id="hide_existing_cmts" value="1" %s>',
            ( isset( $this->comment_link_remove_options['hide_existing_cmts'] ) && $this->comment_link_remove_options['hide_existing_cmts'] === '1' ) ? 'checked' : ''
        );
    }

    public function open_link_innewtab_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[open_link_innewtab]" id="open_link_innewtab" value="1" %s>',
            ( isset( $this->comment_link_remove_options['open_link_innewtab'] ) && $this->comment_link_remove_options['open_link_innewtab'] === '1' ) ? 'checked' : ''
        );
    }
	public function like_dislike() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[like_dislike]" id="like_dislike" value="1" %s>',
            ( isset( $this->comment_link_remove_options['like_dislike'] ) && $this->comment_link_remove_options['like_dislike'] === '1' ) ? 'checked' : ''
        );
    }
    public function enable_comment_like_dislike_filter() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[enable_comment_like_dislike_filter]" id="enable_comment_like_dislike_filter" value="1" %s>',
            ( isset( $this->comment_link_remove_options['enable_comment_like_dislike_filter'] ) && $this->comment_link_remove_options['enable_comment_like_dislike_filter'] === '1' ) ? 'checked' : ''
        );
    }
	public function enable_emotions() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[enable_emotions]" id="enable_emotions" value="1" %s>',
            ( isset( $this->comment_link_remove_options['enable_emotions'] ) && $this->comment_link_remove_options['enable_emotions'] === '1' ) ? 'checked' : ''
        );
    }
	
	public function enable_comment_filter() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[enable_comment_filter]" id="enable_comment_filter" value="1" %s>',
            ( isset( $this->comment_link_remove_options['enable_comment_filter'] ) && $this->comment_link_remove_options['enable_comment_filter'] === '1' ) ? 'checked' : ''
        );
    }
	public function enable_comment_threshold() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[enable_comment_threshold]" id="enable_comment_threshold" value="1" %s>',
            ( isset( $this->comment_link_remove_options['enable_comment_threshold'] ) && $this->comment_link_remove_options['enable_comment_threshold'] === '1' ) ? 'checked' : ''
        );
    }
	public function treshold_score() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[treshold_score]" id="treshold_score" value="%s" placeholder="Ex: 0.5">',
            ( isset( $this->comment_link_remove_options['treshold_score'] ) && $this->comment_link_remove_options['treshold_score'] != '' ) ? $this->comment_link_remove_options['treshold_score'] : '0.5'
        );
		echo '<span style="font-size: 12px;margin-left: 10px;">This will display alert for Comments that contain negative words. Adjust the Threshold Score to accommodate your user base.</span>';
    }
	public function treshold_msg() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[treshold_msg]" id="comment_quick_mgs" value="%s" placeholder="">',
            ( isset( $this->comment_link_remove_options['treshold_msg'] ) && $this->comment_link_remove_options['treshold_msg'] != '' ) ? $this->comment_link_remove_options['treshold_msg'] : 'Your comment is too negative! Please be polite and professional while writing!'
        );
    }

    public function comment_lang_text_filter_comments_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_filter_comments]" id="comment_lang_text_all_comments" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_filter_comments'] ) && $this->comment_link_remove_options['comment_lang_text_filter_comments'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_filter_comments'] : 'Filter Comments by Sentiment'
        );
    }

    public function comment_lang_text_filter_like_dislike_comments_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_filter_like_dislike_comments]" id="comment_lang_text_all_comments" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_filter_like_dislike_comments'] ) && $this->comment_link_remove_options['comment_lang_text_filter_like_dislike_comments'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_filter_like_dislike_comments'] : 'Filter Comments by Like/Dislike'
        );
    }

    public function comment_lang_text_all_comments_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_all_comments]" id="comment_lang_text_all_comments" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_all_comments'] ) && $this->comment_link_remove_options['comment_lang_text_all_comments'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_all_comments'] : 'All Comments'
        );
    }

    public function comment_lang_text_positive_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_positive]" id="comment_lang_text_positive" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_positive'] ) && $this->comment_link_remove_options['comment_lang_text_positive'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_positive'] : 'Positive'
        );
    }

    public function comment_lang_text_negative_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_negative]" id="comment_lang_text_negative" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_negative'] ) && $this->comment_link_remove_options['comment_lang_text_negative'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_negative'] : 'Negative'
        );
    }

    public function comment_lang_text_neutral_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_lang_text_neutral]" id="comment_lang_text_neutral" value="%s" > <i> Filter Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_lang_text_neutral'] ) && $this->comment_link_remove_options['comment_lang_text_neutral'] !='' ) ? $this->comment_link_remove_options['comment_lang_text_neutral'] : 'Neutral'
        );
    }


    public function comment_time_minimum_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[comment_time_minimum]" id="comment_time_minimum" value="%d" >',
            ( isset( $this->comment_link_remove_options['comment_time_minimum'] ) && $this->comment_link_remove_options['comment_time_minimum'] !='' )? $this->comment_link_remove_options['comment_time_minimum']  :10
        );
    }
    public function comment_quick_mgs_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[comment_quick_mgs]" id="comment_quick_mgs" value="%s" >',
            ( isset( $this->comment_link_remove_options['comment_quick_mgs'] ) && $this->comment_link_remove_options['comment_quick_mgs'] !='' ) ? $this->comment_link_remove_options['comment_quick_mgs'] : 'You are posting comments too quickly'
        );
    }
    public function comment_minimum_length_callback() {
        printf(
            '<input type="number" name="comment_link_remove_option_name[comment_minimum_length]" id="comment_minimum_length" value="%d" >',
            ( isset( $this->comment_link_remove_options['comment_minimum_length'] ) && $this->comment_link_remove_options['comment_minimum_length'] !='' )? $this->comment_link_remove_options['comment_minimum_length']  :15
        );
    }
    public function comment_minimum_length_mgs_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[comment_minimum_length_mgs]" id="comment_minimum_length_mgs" value="%s" >',
            ( isset( $this->comment_link_remove_options['comment_minimum_length_mgs'] ) && $this->comment_link_remove_options['comment_minimum_length_mgs'] !='' ) ? $this->comment_link_remove_options['comment_minimum_length_mgs'] : 'Your comments is too short, try to say some more useful messages.'
        );
    }
    public function comment_maximum_length_callback() {
            printf(
                '<input type="number" name="comment_link_remove_option_name[comment_maximum_length]" id="comment_maximum_length" value="%d" >',
                ( isset( $this->comment_link_remove_options['comment_maximum_length'] ) && $this->comment_link_remove_options['comment_maximum_length'] !='' )? $this->comment_link_remove_options['comment_maximum_length']  :1500
            );
    }
    public function comment_maximum_length_mgs_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[comment_maximum_length_mgs]" id="comment_maximum_length_mgs" value="%s" >',
            ( isset( $this->comment_link_remove_options['comment_maximum_length_mgs'] ) && $this->comment_link_remove_options['comment_maximum_length_mgs'] !='' ) ? $this->comment_link_remove_options['comment_maximum_length_mgs'] : 'Your Comments is too long, try to minimize useful message.'
        );
    }

    public function comment_redirect_callback() {
        $clr_options = get_option( 'comment_link_remove_option_name' );


        $comment_redirect = isset($clr_options['comment_redirect']) ? $clr_options['comment_redirect'] : 0;
        wp_dropdown_pages( array(
            'name'              => "comment_link_remove_option_name[comment_redirect]",
            'id'                => 'comment_redirect',
            'depth'             => 0,
            'option_none_value' => 0,
            'selected'          => $comment_redirect,
            'show_option_none'  => __( 'Don\'t redirect first time commenters', 'qc-clr' ),
        ) );

        if (0 != $comment_redirect ) {
            echo '<br><br><a target="_blank" href="' . get_permalink( $clr_options['comment_redirect'] ) . '">' . __( 'Current redirect page', 'qc-clr' ) . '</a>';
        }


    }

    public function comment_exclude_action_callback() {
        $clr_options = get_option( 'comment_link_remove_option_name' );

        $comment_exclude_action = isset($clr_options['comment_exclude_action']) ? $clr_options['comment_exclude_action'] : 0;
        ?>
        <select name="comment_link_remove_option_name[comment_exclude_action]">
            <option value="">Choose an option</option>
            <option value="spam" <?php if($comment_exclude_action=="spam"){ echo 'selected'; }  ?>>Spam</option>
            <option value="pending" <?php if($comment_exclude_action=="pending"){ echo 'selected'; }  ?>> Pending</option>
            <option value="delete" <?php if($comment_exclude_action=="delete"){ echo 'selected'; }  ?>> Delete</option>
        </select>
        <?php


    }
    

    public function show_hide_all_comment_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[show_hide_all_comment]" id="show_hide_all_comment" value="1" %s >',
            ( isset( $this->comment_link_remove_options['show_hide_all_comment'] ) && $this->comment_link_remove_options['show_hide_all_comment'] =='1' ) ? 'checked' : ''
        );
    }

    public function qcld_quick_comment_button_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[qcld_quick_comment_button]" id="qcld_quick_comment_button" value="1" %s >',
            ( isset( $this->comment_link_remove_options['qcld_quick_comment_button'] ) && $this->comment_link_remove_options['qcld_quick_comment_button'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_readmore_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_readmore]" id="comment_readmore" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_readmore'] ) && $this->comment_link_remove_options['comment_readmore'] =='1' ) ? 'checked' : ''
        );
    }

    public function show_hide_all_comment_lang_text_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[show_hide_all_comment_lang_text]" id="show_hide_all_comment_lang_text" value="%s" > <i> Button Caption Text</i>',
            ( isset( $this->comment_link_remove_options['show_hide_all_comment_lang_text'] ) && $this->comment_link_remove_options['show_hide_all_comment_lang_text'] !='' ) ? $this->comment_link_remove_options['show_hide_all_comment_lang_text'] : 'Show All Comments'
        );
    }

    public function show_hide_all_comment_lang_text_hide_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[show_hide_all_comment_lang_text_hide]" id="show_hide_all_comment_lang_text_hide" value="%s" > <i> Button Caption Text</i>',
            ( isset( $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide'] ) && $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide'] !='' ) ? $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide'] : 'Hide All Comments'
        );
    }

    public function show_hide_all_comment_lang_text_write_a_response_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[show_hide_all_comment_lang_text_write_a_response]" id="show_hide_all_comment_lang_text_write_a_response" value="%s" > <i> Button Caption Text</i>',
            ( isset( $this->comment_link_remove_options['show_hide_all_comment_lang_text_write_a_response'] ) && $this->comment_link_remove_options['show_hide_all_comment_lang_text_write_a_response'] !='' ) ? $this->comment_link_remove_options['show_hide_all_comment_lang_text_write_a_response'] : 'Write a Response'
        );
    }

    public function show_hide_all_comment_lang_text_hide_response_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[show_hide_all_comment_lang_text_hide_response]" id="show_hide_all_comment_lang_text_hide_response" value="%s" > <i> Button Caption Text</i>',
            ( isset( $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide_response'] ) && $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide_response'] !='' ) ? $this->comment_link_remove_options['show_hide_all_comment_lang_text_hide_response'] : 'Hide Response'
        );
    }

    public function comment_collapse_replies_lang_comment_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_collapse_replies_lang_comment]" id="comment_collapse_replies_lang_comment" value="%s" > <i> Collapse Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_collapse_replies_lang_comment'] ) && $this->comment_link_remove_options['comment_collapse_replies_lang_comment'] !='' ) ? $this->comment_link_remove_options['comment_collapse_replies_lang_comment'] : 'Comment'
        );
    }

    public function comment_collapse_replies_lang_comments_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_collapse_replies_lang_comments]" id="comment_collapse_replies_lang_comments" value="%s" > <i> Collapse Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_collapse_replies_lang_comments'] ) && $this->comment_link_remove_options['comment_collapse_replies_lang_comments'] !='' ) ? $this->comment_link_remove_options['comment_collapse_replies_lang_comments'] : 'Comments'
        );
    }

    public function comment_collapse_replies_lang_back_callback() {
        printf(
            '<input type="text"  name="comment_link_remove_option_name[comment_collapse_replies_lang_back]" id="comment_collapse_replies_lang_back" value="%s" > <i> Collapse Caption Text</i>',
            ( isset( $this->comment_link_remove_options['comment_collapse_replies_lang_back'] ) && $this->comment_link_remove_options['comment_collapse_replies_lang_back'] !='' ) ? $this->comment_link_remove_options['comment_collapse_replies_lang_back'] : 'Back'
        );
    }

    public function comment_readmore_length_callback() {
        printf(
            '<input type="text" style="width:200px" name="comment_link_remove_option_name[comment_readmore_length]" id="comment_readmore_length" value="%d" >',
            ( isset( $this->comment_link_remove_options['comment_readmore_length'] ) && $this->comment_link_remove_options['comment_readmore_length'] !=0 ) ? $this->comment_link_remove_options['comment_readmore_length'] : 10
        );
    }

    public function comment_link_follow_callback() {

        $clr_options = get_option( 'comment_link_remove_option_name' );
        $comment_link_follow = isset($clr_options['comment_link_follow']) ? $clr_options['comment_link_follow'] : "";
        ?>
        <select name="comment_link_remove_option_name[comment_link_follow]">
            <option value="">Choose an option</option>
            <option value="follow" <?php if($comment_link_follow=="follow"){ echo 'selected'; }  ?>>Add "follow"</option>
            <option value="nofollow" <?php if($comment_link_follow=="nofollow"){ echo 'selected'; }  ?>>Add "nofollow"</option>
        </select>
        <?php
    }

    public function comment_link_ugc_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_ugc]" id="comment_link_ugc" value="ugc" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_ugc'] ) && $this->comment_link_remove_options['comment_link_ugc'] =='ugc' ) ? 'checked' : ''
        );
    }

    public function comment_link_noreffer_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_noreffer]" id="comment_link_noreffer" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_noreffer'] ) && $this->comment_link_remove_options['comment_link_noreffer'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_noopener_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_noopener]" id="comment_link_noopener" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_noopener'] ) && $this->comment_link_remove_options['comment_link_noopener'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post]" id="comment_link_blog_post" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post'] ) && $this->comment_link_remove_options['comment_link_blog_post'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_content_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_content]" id="comment_link_blog_post_content" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_content'] ) && $this->comment_link_remove_options['comment_link_blog_post_content'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_page_content_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_page_content]" id="comment_link_blog_post_page_content" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_page_content'] ) && $this->comment_link_remove_options['comment_link_blog_post_page_content'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_follow_callback() {

        $clr_options = get_option( 'comment_link_remove_option_name' );
        $comment_link_blog_post_follow = isset($clr_options['comment_link_blog_post_follow']) ? $clr_options['comment_link_blog_post_follow'] : "";
        ?>
        <select name="comment_link_remove_option_name[comment_link_blog_post_follow]">
            <option value="">Choose an option</option>
            <option value="follow" <?php if($comment_link_blog_post_follow=="follow"){ echo 'selected'; }  ?>>Add "follow"</option>
            <option value="nofollow" <?php if($comment_link_blog_post_follow=="nofollow"){ echo 'selected'; }  ?>>Add "nofollow"</option>
        </select>
        <?php
    }

    public function comment_link_blog_post_ugc_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_ugc]" id="comment_link_blog_post_ugc" value="ugc" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_ugc'] ) && $this->comment_link_remove_options['comment_link_blog_post_ugc'] =='ugc' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_noreffer_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_noreffer]" id="comment_link_blog_post_noreffer" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_noreffer'] ) && $this->comment_link_remove_options['comment_link_blog_post_noreffer'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_noopener_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_noopener]" id="comment_link_blog_post_noopener" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_noopener'] ) && $this->comment_link_remove_options['comment_link_blog_post_noopener'] =='1' ) ? 'checked' : ''
        );
    }
    // author link
    public function comment_link_blog_post_author_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_author]" id="comment_link_blog_post_author" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_author'] ) && $this->comment_link_remove_options['comment_link_blog_post_author'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_follow_author_callback() {

        $clr_options = get_option( 'comment_link_remove_option_name' );
        $comment_link_blog_post_follow = isset($clr_options['comment_link_blog_post_follow_author']) ? $clr_options['comment_link_blog_post_follow_author'] : "";
        ?>
        <select name="comment_link_remove_option_name[comment_link_blog_post_follow_author]">
            <option value="">Choose an option</option>
            <option value="follow" <?php if($comment_link_blog_post_follow=="follow"){ echo 'selected'; }  ?>>Add "follow"</option>
            <option value="nofollow" <?php if($comment_link_blog_post_follow=="nofollow"){ echo 'selected'; }  ?>>Add "nofollow"</option>
        </select>
        <?php
    }

    public function comment_link_blog_post_ugc_author_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_ugc_author]" id="comment_link_blog_post_ugc_author" value="ugc" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_ugc_author'] ) && $this->comment_link_remove_options['comment_link_blog_post_ugc_author'] =='ugc' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_noreffer_author_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_noreffer_author]" id="comment_link_blog_post_noreffer_author" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_noreffer_author'] ) && $this->comment_link_remove_options['comment_link_blog_post_noreffer_author'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_link_blog_post_noopener_author_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_link_blog_post_author_noopener]" id="comment_link_blog_post_noopener" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_link_blog_post_author_noopener'] ) && $this->comment_link_remove_options['comment_link_blog_post_author_noopener'] =='1' ) ? 'checked' : ''
        );
    }

    // Admin section email individual commenters
    public function comment_admin_section_email_individual_comenters_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_admin_section_email_individual_comenters]" id="comment_admin_section_email_individual_comenters" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_admin_section_email_individual_comenters'] ) && $this->comment_link_remove_options['comment_admin_section_email_individual_comenters'] =='1' ) ? 'checked' : ''
        );
    }

    // A button in the WP toolbar to email all the commenters on a post
    public function comment_button_wp_toolbar_email_commenters_post_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_button_wp_toolbar_email_commenters_post]" id="comment_button_wp_toolbar_email_commenters_post" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_button_wp_toolbar_email_commenters_post'] ) && $this->comment_link_remove_options['comment_button_wp_toolbar_email_commenters_post'] =='1' ) ? 'checked' : ''
        );
    }

    // A button in the WP toolbar to email all the commenters on a post
    public function comment_button_delete_commenters_comment_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_button_delete_commenters_comment]" id="comment_button_delete_commenters_comment" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_button_delete_commenters_comment'] ) && $this->comment_link_remove_options['comment_button_delete_commenters_comment'] =='1' ) ? 'checked' : ''
        );
    }

    // A comment_exclude_comments_callback
    public function comment_exclude_comments_callback() {

        printf(
            '<textarea type="text" name="comment_link_remove_option_name[comment_exclude_text_comments]" id="comment_exclude_text_comments">%s</textarea><p><i>You can add multiple keywords or phrases as coma(,) seperated values. Comments that include these keywords will be automatically deleted or marked as Spam or Pending as you select from the dropdown below.</i></p>',
            ( isset( $this->comment_link_remove_options['comment_exclude_text_comments'] ) && $this->comment_link_remove_options['comment_exclude_text_comments'] !='' ) ? $this->comment_link_remove_options['comment_exclude_text_comments'] : ''
        );


    }

    // Notify a user when their comment is approved.
    public function comment_notify_user_comment_approved_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_notify_user_comment_approved]" id="comment_notify_user_comment_approved" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_notify_user_comment_approved'] ) && $this->comment_link_remove_options['comment_notify_user_comment_approved'] =='1' ) ? 'checked' : ''
        );
    }

    // Notify a user when their comment is approved. notify_user_comment_subject / notify_user_comment_messsage
    public function notify_user_comment_subject_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[notify_user_comment_subject]" id="notify_user_comment_subject" value="%s" >',
            ( isset( $this->comment_link_remove_options['notify_user_comment_subject'] ) && $this->comment_link_remove_options['notify_user_comment_subject'] !='' ) ? $this->comment_link_remove_options['notify_user_comment_subject'] : 'Your comment has been approved'
        );
    }

    // Notify a user when their comment is approved.
    public function notify_user_comment_messsage_callback() {

        printf(
            '<textarea type="text" name="comment_link_remove_option_name[notify_user_comment_messsage]" id="notify_user_comment_messsage">%s</textarea>',
            ( isset( $this->comment_link_remove_options['notify_user_comment_messsage'] ) && $this->comment_link_remove_options['notify_user_comment_messsage'] !='' ) ? $this->comment_link_remove_options['notify_user_comment_messsage'] : 'Thanks for your comment! It has been approved. To view the post, look at the link be'
        );


    }


    // Notify all commenters when anyone post new comment.
    public function notify_all_commenter_messsage_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[notify_all_commenter_messsage]" id="notify_all_commenter_messsage" value="1" %s >',
            ( isset( $this->comment_link_remove_options['notify_all_commenter_messsage'] ) && $this->comment_link_remove_options['notify_all_commenter_messsage'] =='1' ) ? 'checked' : ''
        );
    }

    // Notify all commenters subject
    public function notify_all_commenter_messsage_subject_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[notify_all_commenter_messsage_subject]" id="notify_all_commenter_messsage_subject" value="%s" >',
            ( isset( $this->comment_link_remove_options['notify_all_commenter_messsage_subject'] ) && $this->comment_link_remove_options['notify_all_commenter_messsage_subject'] !='' ) ? $this->comment_link_remove_options['notify_all_commenter_messsage_subject'] : 'New Comment Posted On'
        );
    }

    // Notify all users subject
    public function notify_all_users_messsage_subject_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[notify_all_users_messsage_subject]" id="notify_all_users_messsage_subject" value="%s" >',
            ( isset( $this->comment_link_remove_options['notify_all_users_messsage_subject'] ) && $this->comment_link_remove_options['notify_all_users_messsage_subject'] !='' ) ? $this->comment_link_remove_options['notify_all_users_messsage_subject'] : 'New Comment Posted On'
        );
    }

    // Notify all users subject
    public function notify_only_user_messsage_subject_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[notify_only_user_messsage_subject]" id="notify_only_user_messsage_subject" value="%s" >',
            ( isset( $this->comment_link_remove_options['notify_only_user_messsage_subject'] ) && $this->comment_link_remove_options['notify_only_user_messsage_subject'] !='' ) ? $this->comment_link_remove_options['notify_only_user_messsage_subject'] : 'New Comment Posted On'
        );
    }

    // Notify all User when anyone post new comment.
    public function notify_only_user_commenter_messsage_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[notify_only_user_commenter_messsage]" id="notify_only_user_commenter_messsage" value="1" %s >',
            ( isset( $this->comment_link_remove_options['notify_only_user_commenter_messsage'] ) && $this->comment_link_remove_options['notify_only_user_commenter_messsage'] =='1' ) ? 'checked' : ''
        );
    }

    // Notify all User when anyone post new comment.
    public function notify_all_user_commenter_messsage_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[notify_all_user_commenter_messsage]" id="notify_all_user_commenter_messsage" value="1" %s >',
            ( isset( $this->comment_link_remove_options['notify_all_user_commenter_messsage'] ) && $this->comment_link_remove_options['notify_all_user_commenter_messsage'] =='1' ) ? 'checked' : ''
        );
    }

    // Adds a sidebar widget to show the top commentators in your WP site
    public function comment_add_sidebar_widget_show_top_commentators_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_add_sidebar_widget_show_top_commentators]" id="comment_add_sidebar_widget_show_top_commentators" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_add_sidebar_widget_show_top_commentators'] ) && $this->comment_link_remove_options['comment_add_sidebar_widget_show_top_commentators'] =='1' ) ? 'checked' : ''
        );
    }

    // Adds a sidebar widget to show the top commentators in your WP site
    public function comment_sidebar_widget_show_top_comment_post_page_only_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_sidebar_widget_show_top_comment_post_page_only]" id="comment_sidebar_widget_show_top_comment_post_page_only" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_sidebar_widget_show_top_comment_post_page_only'] ) && $this->comment_link_remove_options['comment_sidebar_widget_show_top_comment_post_page_only'] =='1' ) ? 'checked' : ''
        );
    }

    // Show All Comments
    public function comment_show_all_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_show_all_comments]" id="comment_show_all_comments" value="1" %s ><code>[clr_all_comments][/clr_all_comments]</code> ( Add this shortcode your expected page )',
            ( isset( $this->comment_link_remove_options['comment_show_all_comments'] ) && $this->comment_link_remove_options['comment_show_all_comments'] =='1' ) ? 'checked' : ''
        );
    }
    public function comment_show_private_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_show_private_comments]" id="comment_show_private_comments" value="1" %s > Keep comment private ( visible to site owners only )',
            ( isset( $this->comment_link_remove_options['comment_show_private_comments'] ) && $this->comment_link_remove_options['comment_show_private_comments'] =='1' ) ? 'checked' : ''
        );
    }
    public function comment_collapse_replies_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_collapse_replies_comments]" id="comment_collapse_replies_comments" value="1" %s > Collapse comment replies and show number',
            ( isset( $this->comment_link_remove_options['comment_collapse_replies_comments'] ) && $this->comment_link_remove_options['comment_collapse_replies_comments'] =='1' ) ? 'checked' : ''
        );
    }
    public function comment_show_voice_message_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_show_voice_message_enable]" id="comment_show_voice_message_enable" value="1" %s >    Allow Users to leave Voice Messages with their Comments',
            ( isset( $this->comment_link_remove_options['comment_show_voice_message_enable'] ) && $this->comment_link_remove_options['comment_show_voice_message_enable'] =='1' ) ? 'checked' : ''
        );
    }
    public function comment_show_voice_message_enable_for_woocommerce_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_show_voice_message_enable_for_woocommerce]" id="comment_show_voice_message_enable_for_woocommerce" value="1" %s >    Allow Users to leave Voice Messages with Woocommerce Product Review',
            ( isset( $this->comment_link_remove_options['comment_show_voice_message_enable_for_woocommerce'] ) && $this->comment_link_remove_options['comment_show_voice_message_enable_for_woocommerce'] =='1' ) ? 'checked' : ''
        );
    }

    // Vertical scroll recent comments widget
    public function comment_vertical_scroll_recent_widget_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_vertical_scroll_recent_widget_comments]" id="comment_vertical_scroll_recent_widget_comments" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_vertical_scroll_recent_widget_comments'] ) && $this->comment_link_remove_options['comment_vertical_scroll_recent_widget_comments'] =='1' ) ? 'checked' : ''
        );
    }

    public function comment_pin_commenter_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_pin_commenter_comments]" id="comment_pin_commenter_comments" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_pin_commenter_comments'] ) && $this->comment_link_remove_options['comment_pin_commenter_comments'] =='1' ) ? 'checked' : ''
        );
    }



    // Allows to export the names and email addresses of users, who have left comments on the blog
    public function comment_allows_export_the_names_and_email_addresses_comments_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[comment_allows_export_the_names_and_email_addresses_comments]" id="comment_allows_export_the_names_and_email_addresses_comments" value="1" %s >',
            ( isset( $this->comment_link_remove_options['comment_allows_export_the_names_and_email_addresses_comments'] ) && $this->comment_link_remove_options['comment_allows_export_the_names_and_email_addresses_comments'] =='1' ) ? 'checked' : ''
        );
    }



    // qc_clr_email_subscription_enalbe_disable
    public function qc_clr_email_subscription_enalbe_disable_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[qc_clr_email_subscription_enalbe_disable]" id="qc_clr_email_subscription_enalbe_disable" value="1" %s >',
            ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_enalbe_disable'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_enalbe_disable'] =='1' ) ? 'checked' : ''
        );
    }

    // qc_clr_email_subscription_lang_text
    public function qc_clr_email_subscription_lang_text_callback() {
        printf(
            '<input type="text" name="comment_link_remove_option_name[qc_clr_email_subscription_lang_text]" id="qc_clr_email_subscription_lang_text" value="%s" >',
            ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_lang_text'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_lang_text'] !='' ) ? $this->comment_link_remove_options['qc_clr_email_subscription_lang_text'] : 'Subscribe to our newsletter'
        );
    }

    // qc_clr_email_subscription_zapier_enalbe_disable
    public function qc_clr_email_subscription_zapier_enalbe_disable_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[qc_clr_email_subscription_zapier_enalbe_disable]" id="qc_clr_email_subscription_zapier_enalbe_disable" value="1" %s > %s',
            ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_zapier_enalbe_disable'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_zapier_enalbe_disable'] =='1' ) ? 'checked' : '', ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_zapier_enalbe_disable'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_zapier_enalbe_disable'] =='1' ) ? '<a href="edit.php?post_type=qc_clr_zapier"> Manage Settings</a>' : ''
        );
    }

    // qc_clr_email_subscription_mailchamp_enalbe_disable
    public function qc_clr_email_subscription_mailchamp_enalbe_disable_callback() {
        printf(
            '<input type="checkbox" name="comment_link_remove_option_name[qc_clr_email_subscription_mailchamp_enalbe_disable]" id="qc_clr_email_subscription_mailchamp_enalbe_disable" value="1" %s > %s',
            ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_mailchamp_enalbe_disable'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_mailchamp_enalbe_disable'] =='1' ) ? 'checked' : '',  ( isset( $this->comment_link_remove_options['qc_clr_email_subscription_mailchamp_enalbe_disable'] ) && $this->comment_link_remove_options['qc_clr_email_subscription_mailchamp_enalbe_disable'] =='1' ) ? '<a href="edit.php?post_type=qc_clr_mailchamp"> Manage Settings</a>' : ''
        );
    }



}


if ( is_admin() )
    $comment_link_remove = new CommentLinkProRemove();



